//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------

#ifndef _G3FILE_H_
#define _G3FILE_H_

#include <g3def.h>
#include <io.h>
#include <g3lzss.h>

typedef struct
{
	FILE	*handle;
	UB		*buffer;		// buffer of file
	int    offset;		// current offset in buffer
	int    size;			// size of file
} G3FILE;

typedef struct 
{
	long handle;
	int index;
	char path[_MAX_PATH];
	
} G3FILEFINDER;


BOOL g3bigopen(char *filename);
void g3bigclose(void);

G3FILE *g3fopen(char *filename, char *mode);
size_t g3fread(void *buffer,size_t size,size_t count,G3FILE *file);
size_t g3fwrite(void *buffer, size_t size, size_t count, G3FILE *file );
long g3ftell(G3FILE *file);
int g3fseek( G3FILE *file, long offset, int origin );
int g3fgetc(G3FILE *file);
int g3fclose( G3FILE *stream );


G3FILEFINDER *g3findfirst( char *filespec, struct _finddata_t *fileinfo );
int g3findnext(G3FILEFINDER *finder, struct _finddata_t *fileinfo );
int g3findclose(G3FILEFINDER *finder);


int g3findfile(char *path,char *filename);


int g3feof(G3FILE *file);
void g3freadword(G3FILE *handle,char *ptr);
int g3ffindword(G3FILE *handle,char *w);
int g3ffindword2(G3FILE *handle,char *w1,char *w2);


int g3bigmake(char *path);



#endif
