//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------

#ifndef _G3TGA_H_
#define _G3TGA_H_

#include <g3def.h>
#include <g3rgb.h>
#include <g3utils.h>


class Ctga
{
private:
	int  m_w;
	int  m_h;
	UB   *m_data;
	int	 m_bitdepth;
	Crgb *m_palette;
	union
	{
		UD m_rmask;
		UD m_umask;
	};
	union
	{
		UD m_gmask;
		UD m_vmask;
	};
	union
	{
		UD m_bmask;
		UD m_lmask;
	};
	UD m_amask;

	void _vreverse(void);
public:
	Ctga();	
	~Ctga();
	void release(void);
	int getW(void)const;
	int getH(void)const;
	Crgb getRgb(int x,int y)const;
	Crgb *getPalette(void)const;
	int getBitDepth(void)const;
	UB *getData(void)const;
	BOOL load(char *filename);
	BOOL save(char *filename);
	void convertRgba16(UD rmask,UD gmask,UD bmask,UD amask=0);
	void convertRgba32(UD rmask,UD gmask,UD bmask,UD amask=0);
	void convertUvl16(UD umask,UD vmask,UD lmask);
	void divn(int n);
	void divnSigned(int n);
	void putPixel(int x,int y,Crgb color);
	void setSize(int neww,int newh);

	BOOL getInfoFromFile(char *filename,int *pw,int *ph,int *pbpp);

};

#endif