
//-----------------------------------------------------------------------------
// (C) 2001	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------


#ifndef _G3DYNARRAY_H_
#define _G3DYNARRAY_H_

//-----------------------------------------------------------------------------
//
// Template CdynamicAist : a utiliser pour faire des listes dynamyques
// avec des classe qui ont les bons operateur de recopie par constructeur
//
//-----------------------------------------------------------------------------

#ifdef _DEBUG
	#define DYNAMICARRAY_ALLOC_DEFAULT	1
#else
	#define DYNAMICARRAY_ALLOC_DEFAULT	128
#endif

/*----------------------------------------------------------

les classes Type  doivent avoir les oprateurs suivant :

Type & operator = (Type const &val) 
{
	//
	//	copie avec rallocation si necessaire
	//	cf classe Ctext
	//
	return *this;
}

  le = correspond  un clonage ainsi si un element est dtruit pas de pb

------------------------------------------------------------*/



template <class Type> class CdynamicArray
{
	public:
		Type *m_item;
		int	m_count;
		int	m_rcount;
		int m_allocstep;

		void setallocstep(int value)
		{	
			m_allocstep=value;
		}
		int getallocstep(void)const
		{
			return m_allocstep;
		}

		CdynamicArray(int allocstep=DYNAMICARRAY_ALLOC_DEFAULT)
		{
			m_count=0;
			m_rcount=0;
			m_item=NULL;
			setallocstep(allocstep);
		}

		~CdynamicArray()
		{
			release();
		}

		void release(void)
		{
			if(m_item)
			{
				delete [] m_item;
				m_item=NULL;
			}
			m_count=0;
			m_rcount=0;
		}

		int add(Type &t)
		{
			//_ASSERT(m_count<=m_rcount);
			if(m_count==m_rcount)
			{
				Type *newitem=new Type [m_rcount+m_allocstep];
				m_rcount+=m_allocstep;
				if(m_item!=NULL)
				{
					for(int i=0;i<m_count;i++)
					{
						newitem[i]=m_item[i];
					}
					delete [] m_item; // Here it must be scalar !! with v6
				}
				m_item=newitem;
			}
			m_item[m_count++]=t;
			return m_count-1;
		}

		/*int add(Type *t)
		{
			//_ASSERT(m_count<=m_rcount);
			if(m_count==m_rcount)
			{
				Type *newitem=new Type [m_rcount+m_allocstep];
				m_rcount+=m_allocstep;
				if(m_item!=NULL)
				{
					for(int i=0;i<m_count;i++)
					{
						newitem[i]=m_item[i];
					}
					delete [] m_item; // Here it must be scalar !! with v6
				}
				m_item=newitem;
			}
			m_item[m_count++]=t;
			return m_count-1;
		}
*/

		void addindex(int index,Type &t)
		{
			add(t);
			for(int i=m_count-1;i>index;i--)
			{
				m_item[i]=m_item[i-1];
			}
			m_item[index]=t;
		}
		int	find(Type &t)
		{
			int i;
			for(i=0;i<m_count;i++)
			{
				if(m_item[i]==t)
				{
					return i;
				}
			}
			return -1;
		}
		int addunique(Type &t)
		{
			int idx=find(t);
			if(idx<0)
			{
				idx=add(t);
			}
			return idx;
		}

		int	contains(Type &t)
		{
			int i;
			int count=0;
			for(i=0;i<m_count;i++)
			{
				if(m_item[i] == t)
				{
					count++;
				}
			}
			return count;
		}

		void remove(Type &t)
		{
			int i;
			for(i=0;i<m_count;i++)
			{
				if(m_item[i] == t)
				{
					break;
				}
			}
			delindex(i);
		}

		int delindex(int i)
		{
			int ret=i-1;
			if(ret<0)
				ret=0;
			//_ASSERT(i<m_count);
			m_count--;
			while(i<m_count)
			{
				m_item[i] = m_item[i+1];
				i++;
			}
			return ret;
		}
		void dellast(void)
		{
			delindex(m_count-1);
		}
		int	getcount(void)const{return m_count;}
		Type *getaddr()const
		{
			return m_item;
		}
		Type *getaddr(int i)const
		{
			//_ASSERT(i>=0 && i<m_count);
			return &m_item[i];
		}
		Type *getaddrlast(void)const
		{
			//_ASSERT(m_count>0);
			return &m_item[m_count-1];
		}
		Type &operator[](int i)const
		{
			//_ASSERT(i>=0 && i<m_count);
			return m_item[i];
		}
		void alloc(int count)
		{
			release();
			m_item=new Type [count];
			m_count=count;
			m_rcount=count;
		}
		CdynamicArray<Type> & operator = (CdynamicArray<Type> const &val) 
		{
			release();
			if(val.m_item)
			{
				m_item=new Type [val.m_rcount];
			}
			else
			{
				m_item=NULL;
			}
			m_count=val.m_count;
			m_rcount=val.m_rcount;
			m_allocstep=val.m_allocstep;
			for(int i=0;i<val.m_count;i++)
			{
				m_item[i]=val.m_item[i];
			}
			return *this;
		}

		void sort(void)
		{
			for(int i=0;i<getcount()-1;i++)
			{
				for(int j=i+1;j<getcount();j++)
				{
					if(m_item[i]>m_item[j])
					{
						{
							unsigned char tmp[sizeof(Type)];
							memcpy(&tmp,&m_item[i],sizeof(Type));
							memcpy(&m_item[i],&m_item[j],sizeof(Type));
							memcpy(&m_item[j],&tmp,sizeof(Type));
						}
					}
				}
			}
		}
};



#endif



