//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------

#ifndef _G3GVTX_H_
#define _G3GVTX_H_


#include <g3def.h>
#include <g3uv.h>
#include <g3rgb.h>
#include <g3v2d.h>
#include <d3d.h>

#pragma warning ( disable : 4201 )

//--------------------------------------------------------------------------------
// CGVTX
//--------------------------------------------------------------------------------


class Cgvtx
{
public :
	Cv2d	v2d;		//0
	float	z;			//8
	float	iz;			//12
	union				//16
	{
		struct
		{
			D3DCOLOR    rgbcolor;          /* Vertex color */
		};
		struct
		{
			Crgb		rgb;
		};
	};
	union				//20
	{
		struct 
		{
			D3DCOLOR    rgbspecular;          /* Vertex color */
		};
		struct 
		{
			Crgb		specular;
		};
	};
	union				//24
	{
		struct
		{
			Cuv		uv;		//8
			Cuv		uv2;	//8		// for multiple texturing engines
		};
		struct
		{
			Cuv		tuv[2];	//8
		};
	};
	//int		fog;		//40		//TODO : mettre le fog dans l'alpha du specular ?
	SB clipx;			//44
	SB clipy;			//45
						//46


	Cgvtx() {}
	~Cgvtx() {}
	Cgvtx(SIDEATTR const &attrib,Cgvtx const &a,Cgvtx const &b,float ratio);
	void set(SIDEATTR const &attrib,Cgvtx const &a,Cgvtx const &b,float ratio);
	void set(SIDEATTR const &attrib,Cgvtx *a,Cgvtx *b,float ratio);

	void computeclip2d(float fwinx1,float fwiny1,float fwinx2,float fwiny2)
	{
		clipx=1;
		if(v2d.x<=fwinx2)
		{
			clipx=0;
			if(v2d.x<fwinx1) clipx=-1;
		}
		clipy=1;
		if(v2d.y<=fwiny2)
		{
			clipy=0;
			if(v2d.y<fwiny1) clipy=-1;
		}
	}
	void computeclip2dsetz(float x,float y,float fwinx1,float fwiny1,float fwinx2,float fwiny2)
	{
		z=0.01F;
		iz=1.0F/z;
		v2d.x=x;
		v2d.y=y;
		clipx=1;
		if(x<=fwinx2)
		{
			clipx=0;
			if(x<fwinx1) clipx=-1;
		}
		clipy=1;
		if(y<=fwiny2)
		{
			clipy=0;
			if(y<fwiny1) clipy=-1;
		}
	}
};	

#endif

