//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------


#ifndef _G3LIST_H_
#define _G3LIST_H_

#include <g3file.h>

//-----------------------------------------------------------------------------
//
// Template Clist : a utiliser pour faire des listes dynamyques
// avec des classe qui n'ont pas d'operateur de recopie par constructeur (ca existe....). ou 
// par assignation. Attention aux bugs de release !
//
//-----------------------------------------------------------------------------

#ifdef _DEBUG
	#define LIST_ALLOC_DEFAULT	1
#else
	#define LIST_ALLOC_DEFAULT	128
#endif



class Clistcontainer
{
public:
	int m_container[4];
};



//-----------------------------------------------------------------------------
// a utiliser avec des classes qui ne savant pas faire d'operateur de recopie
// et qui ne contiennent pas de fonction virtuelles
//-----------------------------------------------------------------------------


template <class Type> class Clist
{
	public:
		union		
		{
			struct 
			{
				Type *m_item;		
				int	m_count;		
				int	m_rcount;
				int m_allocstep;
			};
			struct 
			{
				Clistcontainer m_list;
			};
		};

		void setallocstep(int value)
		{	
			m_allocstep=value;
		}
		int getallocstep(void)const
		{
			return m_allocstep;
		}

		Clist(int allocstep=LIST_ALLOC_DEFAULT)
		{
			m_count=0;
			m_rcount=0;
			m_item=NULL;
			setallocstep(allocstep);
		}

		~Clist()
		{
			release();
		}

		void alloc(int s)
		{
			release();
			if(s>0)
			{
				m_count=s;
				m_rcount=s;
				m_item=new Type [m_count];
			}
		}

		void release(void)
		{
			if(m_item)
			{
				for(int i=0;i<m_count;i++)
				{
					//delete m_item[i];
				}
				delete [] m_item;
				m_item=NULL;
			}
			m_count=0;
			m_rcount=0;
		}

		int add(Type const &t)
		{
			if(m_count==m_rcount)
			{
				Type *old=m_item;
				m_item=new Type [m_rcount+m_allocstep];
				m_rcount+=m_allocstep;
				if(old)
				{
					for(int i=0;i<m_count;i++)
					{
						memcpy(&m_item[i],&old[i],sizeof(Type));
						memset(&old[i],0,sizeof(Type));//c'est triste je sais....
					}
					delete  [] old; // Here it must be scalar !! with v6
				}
			}
			m_item[m_count++] = t;
			return m_count-1;
		}

		void addindex(int index,Type const &t)
		{
			add(t);
			for(int i=m_count-1;i>index;i--)
			{
				m_item[i]=m_item[i-1];
			}
			m_item[index]=t;
//			memset(&t,0,sizeof(t));
		}


		int	containsindex(Type const &t)
		{
			int i;
			for(i=0;i<m_count;i++)
			{
				if(m_item[i]==t)
				{
//					memset(&t,0,sizeof(t));
					return i;
				}
			}
			//memset(&t,0,sizeof(t));
			return -1;
		}


		int addunique(Type const &t)
		{
			int idx=containsindex(t);
			if(idx<0)
			{
				idx=add(t);
			}
//			memset(&t,0,sizeof(t));
			return idx;
		}

		int	contains(Type const &t)
		{
			int i;
			int count=0;
			for(i=0;i<m_count;i++)
			{
				if(m_item[i] == t)
				{
					count++;
				}
			}
			//memset(&t,0,sizeof(t));
			return count;
		}

		void remove(Type const &t)
		{
			int i;
			for(i=0;i<m_count;i++)
			{
				if(m_item[i] == t)
				{
					break;
				}
			}
			delindex(i);
			//memset(&t,0,sizeof(t));
		}

		int delindex(int i)
		{
			int ret=i-1;
			if(ret<0)
				ret=0;
			m_count--;
			while(i<m_count)
			{
				m_item[i] = m_item[i+1];
				i++;
			}
			//delete m_item[i];
			memset(&m_item[i],0,sizeof(m_item[i]));
			return ret;
		}
		void dellast(void)
		{
			delindex(m_count-1);
		}

		int	getcount(void)const{return m_count;}
		Type *getaddr()const{return m_item;}
		Type *getaddr(int i)const{return &m_item[i];};
		Type *getaddrlast(void)const{return &m_item[m_count-1];};
		Type &operator[](int i){return m_item[i];}
};







#endif



