
//-----------------------------------------------------------------------------
// (C) 2001	Delphine Software Int 
//
// Author	: LC
//
// Last modified		:
// To do				: 
// Bug Report			:
//-----------------------------------------------------------------------------


#ifndef _CTEXT_H_
#define _CTEXT_H_


#include <string.h>
#include <stdio.h>
//#include <conio.h>
#include <dfile.h>


long crc32(void *ptr,long size,long crc);

class Ctext
{
private:
	char *m_text;
	long m_len;
	long m_crc32;

	void calccrc32(void)
	{
		if(m_text)
		{
			m_crc32=crc32(m_text,strlen(m_text)+1,0L);
		}
		else
		{
			m_crc32=0L;
		}
	}
	void calclen(void)
	{
		if(m_text)
		{
			m_len=strlen(m_text);
		}
		else
		{
			m_len=0;
		}
	}

public:
	Ctext()
	{
		m_text=NULL;
		calccrc32();
		calclen();
	}

	// constructeur 
	Ctext(char const *text)
	{
		if(text)
		{
			m_len=strlen(text);
			m_text=new char [m_len+1];
			strcpy(m_text,text);
		}
		else
		{
			m_text=NULL;
			calclen();
		}
		calccrc32();
	}
	void set(char const *text)
	{
		release();
		if(text)
		{
			m_len=strlen(text);
			m_text=new char [m_len+1];
			strcpy(m_text,text);
			calccrc32();
			calclen();
		}
	}

	char *get(void)const
	{
		return m_text;
	}
	void add(char const *text)
	{
		char *newtext;
		if(text)
		{
			long newlen=m_len+strlen(text);
			newtext=new char [newlen+1];
			strcpy(newtext,m_text);
			strcat(newtext,text);
			release();
			m_text=newtext;
			newtext=NULL;
			m_len=newlen;
			calccrc32();
		}
	}
	int len(void)const
	{
		return m_len;
	}
	void add(Ctext const &text)
	{
		if(text.len()>0)
		{
			char *newtext;
			long newlen=m_len+text.len();
			newtext=new char [newlen+1];
			strcpy(newtext,m_text);
			strcat(newtext,text.get());
			release();
			m_text=newtext;
			newtext=NULL;
			m_len=newlen;
			calccrc32();
		}
	}

	Ctext(Ctext const &text)
	{
		set(text.get());
	}

	void release(void)
	{
		if(m_text)
		{
			delete [] m_text;
			m_text=NULL;
		}
		calccrc32();
		calclen();
	}

	~Ctext()
	{
		release();
	}

	Ctext operator + (Ctext const &text)
	{
		Ctext res(*this);
		res.add(text.get());
		return (res);
	}
	int operator ==(Ctext &text) 
	{
		return(this->m_crc32==text.m_crc32 && this->m_len==text.m_len);
	}
	int operator >=(Ctext &text) 
	{
		int flag;
		flag=::strcmp(text.get(),this->get())>=0;
		return flag;
	}
	int operator >(Ctext &text) 
	{
		int flag;
		flag=::strcmp(text.get(),this->get())>0;
		return flag;
	}
	int operator <=(Ctext &text) 
	{
		int flag;
		flag=::strcmp(text.get(),this->get())<=0;
		return flag;
	}
	int operator <(Ctext &text) 
	{
		int flag;
		flag=::strcmp(text.get(),this->get())<0;
		return flag;
	}
	int operator !=(Ctext &text) 
	{
		int flag=!(*this==text);
		return flag;
	}

	operator char *() {return m_text;}

	Ctext & operator = (Ctext const &text) 
	{
		this->set(text.get());
		return *this;
	}

	int fread(DFILE *handle);
	int fwrite(DFILE *handle);


};

int strlen(Ctext const &text);
Ctext upper(Ctext const &text);

#endif

