//-----------------------------------------------------------------------------
// (C) 2001	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------

#ifndef _G3TIMEDLIST_H_
#define _G3TIMEDLIST_H_



#ifdef _DEBUG
	#define TIMEDLIST_ALLOC_DEFAULT	1
#else
	#define LIST_ALLOC_DEFAULT	128
#endif
#define TIMEDLIST_FLAG_RESET	0x00000001
#define TIMEDLIST_FLAG_SPLINED	0x00000002



template <class Type> class CtimedList
{
	public:
		float *m_time;
		Type *m_item;
		int	m_count;
		int	m_rcount;
		int m_allocstep;

		int getCount(void)const{return m_count;}
		void setAllocStep(int value){m_allocstep=value;}
		int getAllocStep(void)const{return m_allocstep;}


		CtimedList(int allocstep=TIMEDLIST_ALLOC_DEFAULT)
		{
			setAllocStep(alloccount);
			m_count=0;
			m_rcount=0;
			m_item=NULL;
			m_time=NULL;
		}
		void alloc(int count)
		{
			release();
			m_item=new Type [count];
			m_time=new float [count];
			m_count=count;
			m_rcount=count;
		}
		void release(void)
		{
			if(m_item)
			{
				delete [] m_item;
				m_item=NULL;
			}
			if(m_time)
			{
				delete [] m_time;
				m_time=NULL;
			}
			m_count=0;
			m_rcount=0;
		}
		~CtimedList()
		{
			release();
		}
		void insert(Type const &t,float const &time)
		{
			if(m_count==m_rcount)
			{
				Type *olditem=m_item;
				float *oldtime=m_time;
				m_item=new Type [m_rcount+m_allocstep];
				m_time=new float [m_rcount+m_allocstep];
				m_rcount+=m_allocstep;
				if(olditem)
				{
					memcpy(m_item,olditem,sizeof(t)*m_count);
					delete [] olditem;
				}
				if(oldtime)
				{
					memcpy(m_time,oldtime,sizeof(float)*m_count);
					delete [] oldtime;
				}
			}
			int i=0;
			while(i<m_count && m_time[i]<=time)
			{
				i++;
			}
			int j=m_count;
			while(j>i)
			{
				m_item[j]=m_item[j-1];
				m_time[j]=m_time[j-1];
				j--;
			}
			m_item[i]=t;
			m_time[i]=time;
			m_count++;
		}



		Type &operator[](int i){_ASSERT(i>=0 && i<m_count);return m_item[i];}

		int getindex(float time)
		{
			int i=0;
			while(i<m_count && m_time[i]<=time)
			{
				i++;
			}
			if(i<1)
				i=1;
			return i-1;
		}
		int getNearestIndex(float time)
		{
			int i=0;
			float mindist=FLT_MAX;
			float minindex=-1;
			while(i<m_count)
			{
				dist=fabs(m_time[i]-time);
				if(dist<mindist)
				{
					minindex=i;
					mindist=dist;
				}
				i++;
			}
			return minindex;
		}

		Type operator[](float time)
		{
			int index=getindex(time);
			if(m_time[index]==time)
			{
				return m_item[index];
			}
			else
			{
				if(index+1<m_count)
				{
					// ca marche que si les oprateurs * et + et - sont definis sur la classe....
					float difftime=(m_time[index+1]-m_time[index]);
					if(difftime>0)
					{
						return 
							
							
							m_item[index]+((m_item[index+1]-m_item[index])/difftime)*
							(time-m_time[index]);
					}
					else
						return m_item[index];
				}
				else
				{
					return m_item[index];
				}
			}
			return m_item[getindex(time)];
		}

		void destroy(int index)
		{
			for(int i=index;i<m_count-1;i++)
			{
				m_item[i]=m_item[i+1];
				m_time[i]=m_time[i+1];
			}
			m_count--;
		}

		void destroy(float time)
		{
			int index=getindex(time);
			destroy(index);
		}
		float *getTime(void)
		{
			return m_time;
		}

		unsigned int *getFlag(void)
		{
			return m_flag;
		}

};




class  CtimedItemInfo
{
private:
	float m_time;
	unsigned int m_flag;
	float m_duration;
	float m_maxduration;
public:

	float getTime(void)const
	{
		return m_time;
	}
	void setTime(float time)
	{
		m_time=time;
	}
	float getDuration(void)const
	{
		return m_duration;
	}
	void setDuration(float duration)
	{
		m_duration=duration;
	}
	float getMaxDuration(void)const
	{
		return m_maxduration;
	}
	void setMaxDuration(float maxduration)
	{
		m_maxduration=maxduration;
	}

	unsigned int getFlag(void)const
	{
		return m_flag;
	}
	void setFlag(unsigned int flag)
	{
		m_flag=flag;
	}
	int fread(G3FILE *file)
	{
		int version;
		int count=0;
		g3fread(&version,sizeof(version),1,file);
		switch(version)
		{
		case 1:
			{
				count+=g3fread(&m_time,sizeof(m_time),1,file);
				count+=g3fread(&m_flag,sizeof(m_flag),1,file);
				count+=g3fread(&m_duration,sizeof(m_duration),1,file);
				count+=g3fread(&m_maxduration,sizeof(m_maxduration),1,file);
				if(count==4)
					return 1;
			}
			break;
		default:
			{
			}
			break;
		}
		return 0;
	}


	int fwrite(G3FILE *file)
	{
		int version=1;
		int count=0;
		g3fwrite(&version,sizeof(version),1,file);
		count+=g3fwrite(&m_time,sizeof(m_time),1,file);
		count+=g3fwrite(&m_flag,sizeof(m_flag),1,file);
		count+=g3fwrite(&m_duration,sizeof(m_duration),1,file);
		count+=g3fwrite(&m_maxduration,sizeof(m_maxduration),1,file);
		if(count==2)
			return 1;
		return 0;
	}
};

template <class Type> class CtimedClassList
{
	private:
		CtimedItemInfo *m_info;
		Type *m_item;
		int	m_count;
		int	m_rcount;
		int m_allocstep;
	public:


		void setAllocStep(int value)
		{	
			m_allocstep=value;
		}
		int getAllocStep(void)const
		{
			return m_allocstep;
		}

		int getCount(void)const
		{
			return m_count;
		}

		CtimedClassList(int allocstep=TIMEDLIST_ALLOC_DEFAULT)
		{
			setAllocStep(allocstep);
			m_count=0;
			m_rcount=0;
			m_item=NULL;
			m_info=NULL;
		}
		void release(void)
		{
			if(m_item)
			{
				delete [] m_item;
				m_item=NULL;
			}
			if(m_info)
			{
				delete [] m_info;
				m_info=NULL;
			}
			m_count=0;
			m_rcount=0;
		}
		void alloc(int count)
		{
			release();
			m_item=new Type [count+m_allocstep];
			m_info=new CtimedItemInfo [count+m_allocstep];
			m_count=count;
			m_rcount=count+m_allocstep;
		}

		~CtimedClassList()
		{
			release();
		}
		int insert(Type const &t,float const &time)
		{
			if(m_count==m_rcount)
			{
				Type *olditem=m_item;
				CtimedItemInfo *oldinfo=m_info;
				m_item=new Type [m_rcount+m_allocstep];
				_ASSERT(m_item!=NULL);
				m_info=new CtimedItemInfo [m_rcount+m_allocstep];
				_ASSERT(m_info!=NULL);
				m_rcount+=m_allocstep;
				if(olditem)
				{
					memcpy(m_item,olditem,sizeof(t)*m_count);
					delete [] olditem;
				}
				if(oldinfo)
				{
					memcpy(m_info,oldinfo,sizeof(float)*m_count);
					delete [] oldinfo;
				}
			}
			int i=0;
			while(i<m_count && m_info[i].getTime()<=time)
			{
				i++;
			}
			int j=m_count;
			while(j>i)
			{
				m_item[j]=m_item[j-1];
				m_info[j]=m_info[j-1];
				j--;
			}
			m_item[i]=t;
			m_info[i].setTime(time);
			m_info[i].setFlag(0);
			m_info[i].setDuration(0.0F);
			m_info[i].setMaxDuration(0.0F);
			m_count++;
			return i;
		}
		Type &operator[](int i)
		{
			//_ASSERT(i>=0 && i<m_count);
			return m_item[i];
		}

		int getKeyIndex(float time)//attention : ne donne la frame que si elle existe <> getIndex(time)
		{
			int i=0;
			while(i<m_count && m_info[i].getTime()!=time)
			{
				i++;
			}
			if(i<m_count)
				return i;
			return -1;
		}
		float SkipResetPosTime(float time)
		{
			int index=getIndex(time);
			if(index>=0)
			{
				if(m_info[index].getFlag()&TIMEDLIST_FLAG_RESET)
				{
					if(index<m_count-1)
					{
						return SkipResetPosTime(m_info[index+1].getTime());
					}
				}
			}
			return time;
		}

		int getIndex(float time)
		{
			int i=0;
			while(i<m_count && time>=m_info[i].getTime())
			{
				i++;
			}

			if(i<1)
				i=1;
			return i-1;
		}
		float getKeyTime(float time)
		{
			if(m_info==NULL)
			{
				return 0.0F;
			}
			int index=getIndex(time);
			return m_info[index].getTime();
		}


		int canInterpolate(void)
		{
			if(m_count<=0)
			{
				return 0;
			}
			return 1;
		}

		Type *getItem(int index)
		{
				return &m_item[index];
		}
		Type interpolate(float time)
		{
			Type type;
			int index=getIndex(time);
			if(m_info[index].getTime()>=time || index==m_count-1 )
			{
				return m_item[index];
			}
			else
			{
				if(m_info[index].getFlag() & TIMEDLIST_FLAG_RESET)
				{
					// la frame est un reset... pas d'interpolation....
				}
				else
				{
					float difftime=(m_info[index+1].getTime()-m_info[index].getTime());
					if(difftime>0)
					{
						float ratio=(time-m_info[index].getTime())/difftime;
						if(m_info[index].getFlag()&TIMEDLIST_FLAG_SPLINED)
						{
								Type a,b,c,d;
								if(index-1>=0)
								{
									a=m_item[index-1];
								}
								else
								{
									a=m_item[index];
								}
								b=m_item[index];
								if(index+1<m_count)
								{
									c=m_item[index+1];
								}
								else
								{
									c=m_item[index];
								}
								if(index+2<m_count)
								{
									d=m_item[index+2];
								}
								else
								{
									d=m_item[index];
								}
								Type ret;
								ret.spline(a,b,c,d,ratio);
								return ret;
						}
						else
						{
								Type a,b;
								Type ret;
								a=m_item[index];
								if(index+1<m_count)
								{
									b=m_item[index+1];
									ret.interpolate(a,b,ratio);
									return ret;
								}
						}
					}
				}
			}
			return m_item[index];
		}
		Type operator[](float time)
		{
			return interpolate(time);
		}

		void destroy(int index)
		{
			for(int i=index;i<m_count-1;i++)
			{
				m_item[i]=m_item[i+1];
				m_info[i]=m_info[i+1];
			}
			m_count--;
		}

		void destroy(float time)
		{
			int index=getIndex(time);
			destroy(index);
		}

		CtimedItemInfo *getInfo(void)
		{
			return m_info;
		}
		CtimedItemInfo *getInfo(int index)
		{
			_ASSERT(m_info!=NULL);
			_ASSERT(index>=0 && index<m_count);
			return m_info[index];
		}
		unsigned int getFlag(int index)const
		{
			if(m_count)
				return m_info[index].getFlag();
			else
				return 0;
		}
		void setFlag(int index,unsigned int flag)
		{
			_ASSERT(index<m_count);
			m_info[index].setFlag(flag);
		}
		float getTime(int index)const
		{
			if(m_count && m_info)
			{
				return m_info[index].getTime();
			}
			else
			{
				return 0.0F;
			}
		}
		void setTime(int index,float time)
		{
			_ASSERT(index<m_count);
			m_info[index].setTime(time);
		}
		float getDuration(int index)const
		{
			if(m_count && m_info)
			{
				return m_info[index].getDuration();
			}
			else
			{
				return 0.0F;
			}
		}
		void setDuration(int index,float duration)
		{
			_ASSERT(index<m_count);
			m_info[index].setDuration(duration);
		}
		float getMaxDuration(int index)const
		{
			if(m_count && m_info)
			{
				return m_info[index].getMaxDuration();
			}
			else
			{
				return 0.0F;
			}
		}
		void setMaxDuration(int index,float maxduration)
		{
			_ASSERT(index<m_count);
			m_info[index].setMaxDuration(maxduration);
		}
		float getLastTime()const
		{
			if(m_count)
				return m_info[m_count-1].getTime();
			else
				return 0.0F;
		}
		float getFirstTime()const
		{
			if(m_count)
				return m_info[0].getTime();
			else
				return 0.0F;
		}
		void sort(void)
		{
			//oui oui je sais... c'est du tri a papa....
			for(int i=0;i<getCount()-1;i++)
			{
				for(int j=i+1;j<getCount();j++)
				{
					if(m_info[i].getTime()>m_info[j].getTime())
					{
						{
							Type tmp;
							memcpy(&tmp,&m_item[i],sizeof(Type));
							memcpy(&m_item[i],&m_item[j],sizeof(Type));
							memcpy(&m_item[j],&tmp,sizeof(Type));
						}
						{
							CtimedItemInfo tmp;
							tmp=m_info[i];
							m_info[i]=m_info[j];
							m_info[j]=tmp;
						}
					}
				}
			}
		}
		int fread(G3FILE *file)
		{
			int version;
			int count=0;
			int nb;
			g3fread(&version,sizeof(version),1,file);
			g3fread(&nb,sizeof(nb),1,file);
			switch(version)
			{
			case 1:
				{
					alloc(nb);
					for(int i=0;i<nb;i++)
					{
						count+=m_info[i].fread(file);
						count+=m_item[i].fread(file);
					}
					if(count==nb*2)
						return 1;
				}
				break;
			default:
				{
				}
				break;
			}
			return 0;
		}


		int fwrite(G3FILE *file)
		{
			int version=1;
			int count=getCount();
			g3fwrite(&version,sizeof(version),1,file);
			g3fwrite(&count,sizeof(count),1,file);
			count=0;
			for(int i=0;i<getCount();i++)
			{
				count+=m_info[i].fwrite(file);
				count+=m_item[i].fwrite(file);
			}
			if(count==getCount()*2)
				return 1;
			return 0;
		}


		int save(char *filename)
		{
			G3FILE *file;
			file=g3fopen(filename,"wb");
			if(file)
			{
				fwrite(file);
				g3fclose(file);
			}
			return 1;
		}

		int load(char *filename)
		{
			G3FILE *file;
			file=g3fopen(filename,"rb");
			if(file)
			{
				fread(file);
				g3fclose(file);
			}
			return 1;
		}
		int getNearestIndex(float time)
		{
			int i=0;
			float mindist=FLT_MAX;
			int minindex=-1;
			while(i<m_count)
			{
				float dist=(float)fabs(m_info[i].getTime()-time);
				if(dist<mindist)
				{
					minindex=i;
					mindist=dist;
				}
				i++;
			}
			return minindex;
		}
};





#endif







