//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
//	Comment :
//	direct draw & direct 3d interface
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <stdafx.h>


#include <g3def.h>
#include <g3dd.h>
#include <g3tga.h>

#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include <process.h>

#define DDCLIPPING		// for self clipping

// main info


// rasterization driver info




DWORD FLOATtoDWORD( FLOAT f )
{
    union FLOATDWORD
    {
        FLOAT f;
        DWORD dw;
    };

    FLOATDWORD val;
    val.f = f;
    return val.dw;
}

void Cdd::ddError(HRESULT err,int line)
{
	char *ddmsg;
	ddmsg=(char *)DXGetErrorString8(err);
    outputdebug("CDD::ERR:0x%x %s line %d\n",err,ddmsg,line);
}



/**************************************************************************
  Cdd::finddepthstencilformat
 **************************************************************************/
int __cdecl sortmodescallback( const VOID* arg1, const VOID* arg2 )
{
    D3DDISPLAYMODE* p1 = (D3DDISPLAYMODE*)arg1;
    D3DDISPLAYMODE* p2 = (D3DDISPLAYMODE*)arg2;
    if( p1->Format > p2->Format )   return -1;
    if( p1->Format < p2->Format )   return +1;
    if( p1->Width  < p2->Width )    return -1;
    if( p1->Width  > p2->Width )    return +1;
    if( p1->Height < p2->Height )   return -1;
    if( p1->Height > p2->Height )   return +1;
    return 0;
}


/**************************************************************************
  Cdd::finddepthstencilformat
 **************************************************************************/
int Cdd::confirmDevice(D3DCAPS8* pCaps, DWORD dwBehavior,D3DFORMAT Format )
{
    if( dwBehavior & D3DCREATE_PUREDEVICE )
        return FALSE;	// GetTransform doesn't work on PUREDEVICE
    return TRUE;
}


/**************************************************************************
  Cdd::finddepthstencilformat
 **************************************************************************/
BOOL Cdd::findDepthStencilFormat( UINT iAdapter, D3DDEVTYPE DeviceType,
    D3DFORMAT TargetFormat, D3DFORMAT* pDepthStencilFormat )
{
	HRESULT err;
	//provisoire
	int m_dwMinDepthBits=16;
	int	m_dwMinStencilBits=0;

    if( m_dwMinDepthBits <= 16 && m_dwMinStencilBits == 0 )
    {
        err=m_d3d->CheckDeviceFormat(
			iAdapter,
			DeviceType,
            TargetFormat,
			D3DUSAGE_DEPTHSTENCIL,
			D3DRTYPE_SURFACE,
			D3DFMT_D16
			);
		if(err==D3D_OK)
        {
			err=m_d3d->CheckDepthStencilMatch(
				iAdapter,
				DeviceType,
				TargetFormat,
				TargetFormat,
				D3DFMT_D16);
			if(err==D3D_OK)
            {
                *pDepthStencilFormat = D3DFMT_D16;
                return TRUE;
            }
			else
			{
				DDERROR(err);
			}
        }
		else
		{
			DDERROR(err);
		}
    }

    if(m_dwMinDepthBits<= 15 && m_dwMinStencilBits<=1 )
    {
        err=m_d3d->CheckDeviceFormat(
			iAdapter,
			DeviceType,
			TargetFormat,
			D3DUSAGE_DEPTHSTENCIL,
			D3DRTYPE_SURFACE,
			D3DFMT_D15S1
			);
		if(err==D3D_OK)
        {
            err=m_d3d->CheckDepthStencilMatch(
				iAdapter,
				DeviceType,
				TargetFormat,
				TargetFormat,
				D3DFMT_D15S1
				);
			if(err==D3D_OK)
            {
                *pDepthStencilFormat = D3DFMT_D15S1;
                return TRUE;
            }
			else
			{
				DDERROR(err);
			}
        }
		else
		{
			DDERROR(err);
		}
    }

    if(m_dwMinDepthBits<= 24 && m_dwMinStencilBits==0)
    {
        err=m_d3d->CheckDeviceFormat(
			iAdapter,
			DeviceType,
            TargetFormat,
			D3DUSAGE_DEPTHSTENCIL,
			D3DRTYPE_SURFACE,
			D3DFMT_D24X8
			);
		if(err==D3D_OK)
        {
			err=m_d3d->CheckDepthStencilMatch(
				iAdapter,
				DeviceType,
                TargetFormat,
				TargetFormat,
				D3DFMT_D24X8
				);
			if(err==D3D_OK)
            {
                *pDepthStencilFormat = D3DFMT_D24X8;
                return TRUE;
            }
			else
			{
				DDERROR(err);
			}
        }
		else
		{
			DDERROR(err);
		}
    }

    if( m_dwMinDepthBits <= 24 && m_dwMinStencilBits <= 8 )
    {
        err=m_d3d->CheckDeviceFormat(
			iAdapter,
			DeviceType,
            TargetFormat,
			D3DUSAGE_DEPTHSTENCIL,
			D3DRTYPE_SURFACE,
			D3DFMT_D24S8);
		if(err==D3D_OK)
        {
			err=m_d3d->CheckDepthStencilMatch(
				iAdapter,
				DeviceType,
                TargetFormat,
				TargetFormat,
				D3DFMT_D24S8
				);
			if(err==D3D_OK)
            {
                *pDepthStencilFormat = D3DFMT_D24S8;
                return TRUE;
            }
			else
			{
				DDERROR(err);
			}
        }
		else
		{
			DDERROR(err);
		}
    }

    if( m_dwMinDepthBits <= 24 && m_dwMinStencilBits <= 4 )
    {
        if( SUCCEEDED( m_d3d->CheckDeviceFormat( iAdapter, DeviceType,
            TargetFormat, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D24X4S4 ) ) )
        {
            if( SUCCEEDED( m_d3d->CheckDepthStencilMatch( iAdapter, DeviceType,
                TargetFormat, TargetFormat, D3DFMT_D24X4S4 ) ) )
            {
                *pDepthStencilFormat = D3DFMT_D24X4S4;
                return TRUE;
            }
        }
    }

    if( m_dwMinDepthBits <= 32 && m_dwMinStencilBits == 0 )
    {
        if( SUCCEEDED( m_d3d->CheckDeviceFormat( iAdapter, DeviceType,
            TargetFormat, D3DUSAGE_DEPTHSTENCIL, D3DRTYPE_SURFACE, D3DFMT_D32 ) ) )
        {
            if( SUCCEEDED( m_d3d->CheckDepthStencilMatch( iAdapter, DeviceType,
                TargetFormat, TargetFormat, D3DFMT_D32 ) ) )
            {
                *pDepthStencilFormat = D3DFMT_D32;
                return TRUE;
            }
        }
    }
    return FALSE;
}

/**************************************************************************
  Cdd::builddevicelist
 **************************************************************************/
HRESULT Cdd::buildDeviceList(void)
{
    const DWORD dwNumDeviceTypes=2;
    const TCHAR* strDeviceDescs[]={ _T("HAL"), _T("REF") };
    const D3DDEVTYPE DeviceTypes[]={ D3DDEVTYPE_HAL,D3DDEVTYPE_REF};

    BOOL bHALExists = FALSE;
    BOOL bHALIsWindowedCompatible = FALSE;
    BOOL bHALIsDesktopCompatible = FALSE;
    BOOL bHALIsSampleCompatible = FALSE;

    // Loop through all the adapters on the system (usually, there's just one
    // unless more than one graphics card is present).
    for(unsigned int driver=0;driver<m_d3d->GetAdapterCount();driver++)
    {
        // Fill in adapter info
        //m_driver[m_drivercurrent];
		m_d3d->GetAdapterIdentifier( driver, 0, &m_driver[driver].m_identifier );
        m_d3d->GetAdapterDisplayMode( driver, &m_driver[driver].m_desktopdisplaymode );
		memset(m_driver[driver].m_device,0,sizeof(CddDevice)*DD_DEVICEMAX);
        m_driver[driver].m_devicecount=0;
        m_driver[driver].m_devicecurrent=0;

        // Enumerate all display modes on this adapter
        D3DDISPLAYMODE modes[DD_MODEMAX];
        D3DFORMAT formats[20];
        int formatcount=0;
        int modecount=0;
        // Add the adapter's current desktop format to the list of formats
        formats[formatcount++] = m_driver[driver].m_desktopdisplaymode.Format;
        for(int mode=0;mode<(int)m_d3d->GetAdapterModeCount(driver);mode++ )
        {
			int m;
            // Get the display mode attributes
            D3DDISPLAYMODE displaymode;
            m_d3d->EnumAdapterModes(driver,mode,&displaymode);
            // Filter out low-resolution modes
            if( displaymode.Width<640 || displaymode.Height<400)
                continue;
            // Check if the mode already exists (to filter out refresh rates)
            for(m=0;m<(int)m_d3d->GetAdapterModeCount(driver);m++)
            {
                if( ( modes[m].Width  == displaymode.Width  ) &&
                    ( modes[m].Height == displaymode.Height ) &&
                    ( modes[m].Format == displaymode.Format ) )
                    break;
            }
            // If we found a new mode, add it to the list of modes
            if(m==(int)m_d3d->GetAdapterModeCount(driver))
            {
                modes[modecount].Width       = displaymode.Width;
                modes[modecount].Height      = displaymode.Height;
                modes[modecount].Format      = displaymode.Format;
                modes[modecount].RefreshRate = 0;
                modecount++;

                // Check if the mode's format already exists
                for(int f=0; f<formatcount; f++ )
                {
                    if( displaymode.Format==formats[f] )
                        break;
                }
                // If the format is new, add it to the list
                if(f==formatcount)
				{
                    formats[formatcount++] = displaymode.Format;
				}
            }
        }

        // Sort the list of display modes (by format, then width, then height)
        qsort(modes,modecount,sizeof(D3DDISPLAYMODE),sortmodescallback);

        // Add devices to adapter
        for(unsigned int device=0;device<dwNumDeviceTypes;device++ )
        {
            // Fill in device info
            CddDevice *pdevice;
            pdevice                 = &m_driver[driver].m_device[device];
            pdevice->m_type			= DeviceTypes[device];

            m_d3d->GetDeviceCaps(driver,pdevice->m_type,&pdevice->m_caps );
            //pdevice->strDesc        = strDeviceDescs[device];
            pdevice->m_modecount    = 0;
            pdevice->m_modecurrent  = 0;
            pdevice->m_candowindowed= FALSE;
            pdevice->m_windowed     = FALSE;
            pdevice->m_multisampletype = D3DMULTISAMPLE_NONE;

            // Examine each format supported by the adapter to see if it will
            // work with this device and meets the needs of the application.
            BOOL  bFormatConfirmed[20];
            DWORD dwBehavior[20];
            D3DFORMAT fmtDepthStencil[20];
            for(int f=0; f<formatcount; f++ )
            {
                bFormatConfirmed[f] = FALSE;
                fmtDepthStencil[f] = D3DFMT_UNKNOWN;

                // Skip formats that cannot be used as render targets on this device
                if( m_d3d->CheckDeviceType( driver, pdevice->m_type,formats[f],formats[f],FALSE)!=D3D_OK ) 
                    continue;
                if(pdevice->m_type == D3DDEVTYPE_HAL )
                {
                    // This system has a HAL device
                    bHALExists=TRUE;
                    if( pdevice->m_caps.Caps2 & D3DCAPS2_CANRENDERWINDOWED )
                    {
                        // HAL can run in a window for some mode
                        bHALIsWindowedCompatible=TRUE;

                        if( f == 0 )
                        {
                            // HAL can run in a window for the current desktop mode
                            bHALIsDesktopCompatible=TRUE;
                        }
                    }
                }

                // Confirm the device/format for HW vertex processing
                if( pdevice->m_caps.DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT )
                {
                    if( pdevice->m_caps.DevCaps & D3DDEVCAPS_PUREDEVICE )
                    {
                        dwBehavior[f] = D3DCREATE_HARDWARE_VERTEXPROCESSING |
                                        D3DCREATE_PUREDEVICE;

                        if(confirmDevice(&pdevice->m_caps,dwBehavior[f],formats[f]))
						{
                            bFormatConfirmed[f] = TRUE;
						}
                    }

                    if (FALSE == bFormatConfirmed[f] )
                    {
                        dwBehavior[f] = D3DCREATE_HARDWARE_VERTEXPROCESSING;

                        if( confirmDevice( &pdevice->m_caps, dwBehavior[f],formats[f] ))
                            bFormatConfirmed[f] = TRUE;
                    }

                    if ( FALSE == bFormatConfirmed[f] )
                    {
                        dwBehavior[f] = D3DCREATE_MIXED_VERTEXPROCESSING;

                        if( confirmDevice( &pdevice->m_caps, dwBehavior[f],formats[f] ))
                            bFormatConfirmed[f] = TRUE;
                    }
                }

                // Confirm the device/format for SW vertex processing
                if( FALSE == bFormatConfirmed[f] )
                {
                    dwBehavior[f] = D3DCREATE_SOFTWARE_VERTEXPROCESSING;

                    if( confirmDevice( &pdevice->m_caps, dwBehavior[f],formats[f]))
                        bFormatConfirmed[f] = TRUE;
                }

                // Find a suitable depth/stencil buffer format for this device/format
                if( bFormatConfirmed[f])
                {
                    if( !findDepthStencilFormat( driver, pdevice->m_type,
                        formats[f], &fmtDepthStencil[f] ) )
                    {
                        bFormatConfirmed[f] = FALSE;
                    }
                }
            }

            // Add all enumerated display modes with confirmed formats to the
            // device's list of valid modes
            for(int m=0;m<modecount;m++)
            {
                for(int f=0;f<formatcount;f++)
                {
                    if(modes[m].Format==formats[f])
                    {
                        if(bFormatConfirmed[f]==TRUE)
                        {
                            // Add this mode to the device's list of valid modes
                            pdevice->m_mode[pdevice->m_modecount].setW(modes[m].Width);
                            pdevice->m_mode[pdevice->m_modecount].setH(modes[m].Height);
                            pdevice->m_mode[pdevice->m_modecount].setFormat(modes[m].Format);
                            pdevice->m_mode[pdevice->m_modecount].setBehavior(dwBehavior[f]);
                            pdevice->m_mode[pdevice->m_modecount].setDepthStencilFormat(fmtDepthStencil[f]);
                            pdevice->m_modecount++;

                            if( pdevice->m_type == D3DDEVTYPE_HAL )
                                bHALIsSampleCompatible = TRUE;
                        }
                    }
                }
            }

            // Select any 640x480 mode for default (but prefer a 16-bit mode)
            for(m=0;m<pdevice->m_modecount;m++)
            {
                if(pdevice->m_mode[m].getW()==640 && pdevice->m_mode[m].getH()==480 )
                {
                    pdevice->m_modecurrent=m;
                    if( pdevice->m_mode[m].getFormat()==D3DFMT_R5G6B5 ||
                        pdevice->m_mode[m].getFormat()==D3DFMT_X1R5G5B5 ||
                        pdevice->m_mode[m].getFormat()==D3DFMT_A1R5G5B5 )
                    {
                        break;
                    }
                }
            }

            // Check if the device is compatible with the desktop display mode
            // (which was added initially as formats[0])
            if( bFormatConfirmed[0] && (pdevice->m_caps.Caps2 & D3DCAPS2_CANRENDERWINDOWED) )
            {
                pdevice->m_candowindowed=TRUE;
                pdevice->m_windowed     =TRUE;
            }

            // If valid modes were found, keep this device
            if( pdevice->m_modecount>0)
                m_driver[driver].m_devicecount++;
        }

        // If valid devices were found, keep this adapter
        if(m_driver[driver].m_devicecount>0)
            m_drivercount++;
    }

    // Return an error if no compatible devices were found
    if(m_drivercount==0)
        return E_FAIL;

    // Pick a default device that can render into a window
    // (This code assumes that the HAL device comes before the REF
    // device in the device array).
	{
		for(int driver=0;driver<m_drivercount;driver++)
		{
			for(int device=0;device<m_driver[driver].m_devicecount;device++)
			{
				if(m_driver[driver].m_device[device].m_windowed)
				{
					m_driver[driver].m_devicecurrent=device;
					m_drivercurrent=driver;
					m_fullscreen=FALSE;
					return D3D_OK;
				}
			}
		}
	}
    return E_FAIL;
}

/**************************************************************************
  Cdd::constructor
 **************************************************************************/

Cdd::Cdd(void)
{
	HRESULT err;
	m_d3d=NULL;
	m_device=NULL;
	m_trianglevertexbuffer8=NULL;
	m_linevertexbuffer8=NULL;
    m_d3d=Direct3DCreate8( D3D_SDK_VERSION );
    if(m_d3d!=NULL)
	{
		m_texturedividestart=DD_TEXTUREDIVIDESTART;
		// default settings
		m_rmask=0;
		m_gmask=0;
		m_bmask=0;
		m_hwnd=NULL;
		m_zbufferenable=TRUE;
		m_stencilenable=FALSE;
		m_rendermipmap=DD_MIPMAP_LINEAR;
		m_renderfilter=DD_FILTER_LINEAR;
		m_fullscreen=FALSE;
		m_texture32=TRUE;
		m_novsync=FALSE;
		//clear texture buffer
		memset(&m_texture[0],0,DD_TEXTUREMAX*sizeof(DDTEXTURE));
		// enumerate drivers and devices
		m_drivercount=0;
		m_drivercurrent=0;
		m_driverchanged=TRUE;
		m_usetexturestagemax=3;
		m_drivercurrent=0;
		m_beginrendercount=0;
		m_insetformat=FALSE;
		m_backbuffercount=1;
		m_hwnd=NULL;
		m_renderfilter=DD_FILTER_LINEAR;
		m_renderdither=TRUE;
		m_renderzbuffer=TRUE;
		m_renderantialias=FALSE;
		m_renderfog=FALSE;
		m_renderfogcolor=Crgb(0,0,0,0);
		m_rendermipmap=DD_MIPMAP_LINEAR;
		err=buildDeviceList();
		if(err==D3D_OK)
		{
			setZbufferMax(8192.0F);
			//DX8m_zbufferformatcurrent=0;
		}
	}
	setFontRgb(Crgb(128,128,128,255));
}


Cdd::~Cdd()
{
	releaseAllTexture();
	releaseAll();
	if(m_d3d!=NULL)
	{
		int cnt;
		cnt=m_d3d->Release();
		outputdebug("CDD::D3d released %d\n",cnt);
		m_d3d=NULL;
	}
}


BOOL Cdd::ready(void)
{
  return(
		m_d3d &&
		m_device &&
		!m_insetformat
		);
}

void Cdd::setDriverCurrent(int driver)
{
	if(m_drivercurrent!=driver % m_drivercount)
	{
		m_drivercurrent=driver % m_drivercount;
		m_driverchanged=TRUE;
	}
	outputdebug("CDD::setdrivercurrent %d %s\n",getDriverCurrent(),getDriverName());
} 

void Cdd::releaseAll(void)
{
	_ASSERT(m_beginrendercount==0);
	int cnt;
	if(m_trianglevertexbuffer8)
	{
		m_trianglevertexbuffer8->Release();
		m_trianglevertexbuffer8=NULL;
	}
	if(m_linevertexbuffer8)
	{
		m_linevertexbuffer8->Release();
		m_linevertexbuffer8=NULL;
	}
	if(m_device)
	{
		cnt=m_device->Release();
		outputdebug("CDD::Device released %d\n",cnt);
		m_device=NULL;
	}

}





void Cdd::setUseTextureStageMax(int val)
{
	_ASSERT(m_beginrendercount==0);
	m_usetexturestagemax=val;
	m_texturestagemax=MIN(getDeviceCurrentAddr()->m_caps.MaxSimultaneousTextures,getDeviceCurrentAddr()->m_caps.MaxTextureBlendStages);
	// if bump format not found... 
/*	if(Cdd::m_textureformat[DDBESTTEXTUREFORMAT_BUMPDUDV16].ddpfPixelFormat.dwSize==0)
	{
		m_texturestagemax=MIN(m_texturestagemax,2);
	}
*/	m_texturestagemax=MIN(m_texturestagemax,m_usetexturestagemax);
}


/**************************************************************************
  Cdd::setformat
 **************************************************************************/
BOOL Cdd::setFormat(HWND hwnd,int fullscreen)
{
	HRESULT err;
	if(m_insetformat)
	{
		// calling set format while in setformat 
		outputdebug("CDD::Setformat (ever in set format -> so return)\n");
		return TRUE;
	}
	outputdebug("--------------------------------------------------------------------------------\n");
	outputdebug("CDD::Setformat (entering in...) CURR FS=%d NEW FS:%d\n",getFullScreen(),fullscreen);
	int oldfullscreen=m_fullscreen;
	m_hwnd=hwnd;
	// fullscreen asked
	if(fullscreen)
	{
		if(!m_fullscreen)
		{
			// we were not in fullscreen mode so save coords of current window
			m_hwndstyle=GetWindowLong(hwnd,GWL_STYLE);
			GetWindowRect(hwnd, &m_hwndrect);
			SetWindowLong(hwnd,GWL_STYLE,WS_POPUP|WS_VISIBLE);
			outputdebug("CDD::Saving window rect %dx%d\n",m_hwndrect.right - m_hwndrect.left,m_hwndrect.bottom - m_hwndrect.top);
		}
		else
		{
		}
		m_fullscreen=TRUE;
		m_w=getModeCurrentAddr()->getW();
		m_h=getModeCurrentAddr()->getH();
	}
	else
	// windowed mode asked
	{
		// we were in fullscreen, so restore coord of window
		if(m_fullscreen)
		{
			// comming from fullscreen mode
			SetWindowLong(hwnd,GWL_STYLE,m_hwndstyle );
			SetWindowPos(hwnd,HWND_NOTOPMOST,m_hwndrect.left,m_hwndrect.top,
						 (m_hwndrect.right - m_hwndrect.left), 
						 (m_hwndrect.bottom - m_hwndrect.top), SWP_SHOWWINDOW );
			outputdebug("Restoring window rect %dx%d\n",m_hwndrect.right - m_hwndrect.left,m_hwndrect.bottom - m_hwndrect.top);
		}
		else
		{
			// ever from windowed mode

		}
		m_fullscreen=FALSE;
		// Get the dimensions of the viewport and screen bounds
		RECT rc;
		GetClientRect( hwnd, &rc);
		m_w=rc.right;
		m_h=rc.bottom;
		if(m_w==0 || m_h==0)
		{
			return TRUE;
		}
	}

	releaseAllTexture();
	releaseAll();


	// create device
    D3DPRESENT_PARAMETERS d3dpp;         
    memset(&d3dpp,0,sizeof(d3dpp) );
    d3dpp.Windowed               = getDeviceCurrentAddr()->m_windowed;
    d3dpp.BackBufferCount        = 1;
    d3dpp.MultiSampleType        = getDeviceCurrentAddr()->m_multisampletype;
    d3dpp.SwapEffect             = D3DSWAPEFFECT_DISCARD;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = getModeCurrentAddr()->getDepthStencilFormat();
    d3dpp.hDeviceWindow          = m_hwnd;
    if( !m_fullscreen)
    {
        d3dpp.BackBufferWidth  = m_w;
        d3dpp.BackBufferHeight = m_h;
        d3dpp.BackBufferFormat = getDriverCurrentAddr()->m_desktopdisplaymode.Format;
    }
    else
    {
        d3dpp.BackBufferWidth  = m_w;
        d3dpp.BackBufferHeight = m_h;
        d3dpp.BackBufferFormat = getModeCurrentAddr()->getFormat();
    }
    // Create the device
    err=m_d3d->CreateDevice( m_drivercurrent,getDeviceCurrentAddr()->m_type,m_hwnd,getModeCurrentAddr()->getBehavior(),&d3dpp,
                               &m_device);
    if(err!=D3D_OK)
	{
		DDERROR(err);
        goto error;
    }
	outputdebug("CDD::Device created\n");

	//create the triangle vertex buffer
	err=m_device->CreateVertexBuffer(
		DD_TRIANGLEVERTEXMAX*sizeof(CddTlVertex),
		0,
		D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_SPECULAR|D3DFVF_TEX2,
		D3DPOOL_DEFAULT,
		&m_trianglevertexbuffer8);
    if(err!=D3D_OK)
	{
		DDERROR(err);
        goto error;
    }
	//create the line vertex buffer
	err=m_device->CreateVertexBuffer(
		DD_LINEVERTEXMAX*sizeof(CddTlLineVertex),
		0,
		D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_SPECULAR,
		D3DPOOL_DEFAULT,
		&m_linevertexbuffer8);
    if(err!=D3D_OK)
	{
		DDERROR(err);
        goto error;
    }

	setUseTextureStageMax(m_usetexturestagemax);
	// get backbuffer surface desc
	outputdebug("CDD::Setformat Done %dx%d bpp%d fs%d\n",m_w,m_h,m_bpp,m_fullscreen);
	outputdebug("--------------------------------------------------------------------------------\n");
	m_insetformat=FALSE;

	

	setClipRect(0,0,m_w,m_h);
	return TRUE;



error:
	outputdebug("CDD::Setformat ERROR %dx%d bpp%d fs%d\n",m_w,m_h,m_bpp,m_fullscreen);
	outputdebug("--------------------------------------------------------------------------------\n");
	releaseAllTexture();
	releaseAll();
	m_fullscreen=oldfullscreen; // restore full screen status
	m_insetformat=FALSE;
	return FALSE;
}


void Cdd::setClipRect(int x1,int y1,int x2,int y2)
{
	HRESULT err;
	m_winx1=x1;
	m_winy1=y1;
	m_winx2=x2;
	m_winy2=y2;
	m_fwinx1=(float)x1;
	m_fwiny1=(float)y1;
	m_fwinx2=(float)x2;
	m_fwiny2=(float)y2;
	if(m_device)
	{
		
			static D3DVIEWPORT8 viewdata = { 0, 0, m_w, m_h, 0.0f, 1.0f };
			viewdata.X=x1;
			viewdata.Y=y1;
			viewdata.Width=(x2-x1);
			viewdata.Height=(y2-y1);
			viewdata.MinZ=0.0F;
			viewdata.MaxZ=1.0F;
			err=m_device->SetViewport(&viewdata);
			if( err!=D3D_OK )
			{
				DDERROR(err);
			}
	}
}

void Cdd::setClipRect(Cv2d const &v1,Cv2d const &v2)
{
	setClipRect(float2int(v1.x),float2int(v1.y),float2int(v2.x),float2int(v2.y));
}

/**************************************************************************
  Cdd::restoresurfaces(void)
 **************************************************************************/

int Cdd::restoreSurfaces(void)
{
/*	HRESULT err;
	err=D3D_OK;
	if(m_primary)
	{
		err=m_primary->Restore();
		if(err!=D3D_OK)
		{
			DDERROR(err);
			return err;
		}
	}
	if(m_backbuffer)
	{
		err=m_backbuffer->Restore();
		if(err!=D3D_OK)
		{
			DDERROR(err);
			return err;
		}
	}
	if(m_zbuffer)
	{
		err=m_zbuffer->Restore();
		if(err!=D3D_OK)
		{
			DDERROR(err);
			return err;
		}
	}
	return(err);
*/
	return 1;
}

/**************************************************************************
  Cdd::flip
 **************************************************************************/
BOOL Cdd::flip(void)
{
	HRESULT err;
	if(m_device)
	{
		err=m_device->Present( NULL, NULL, NULL, NULL );
		if(err!=D3D_OK)
		{
			DDERROR(err);
			return FALSE;
		}
		return TRUE;
	}
	return FALSE;
}

BOOL Cdd::blt(
	int src_x1,int src_y1,int src_x2,int src_y2,
	int dst_x1,int dst_y1,int dst_x2,int dst_y2
	)
{
/*
		_ASSERT(m_beginrendercount==0);
		HRESULT err;
		RECT dst_rc;
		RECT src_rc;

		dst_rc.left=dst_x1;
		dst_rc.top=dst_y1;
		dst_rc.right=dst_x2;
		dst_rc.bottom=dst_y2;

		src_rc.left=src_x1;
		src_rc.top=src_y1;
		src_rc.right=src_x2;
		src_rc.bottom=src_y2;

		err=m_backbuffer->Blt(&dst_rc,m_backbuffer,&src_rc,DDBLT_WAIT,NULL);
		if( err!=D3D_OK )
		{
			DDERROR(err);
			return FALSE;
		}
*/
		return TRUE;
}

/**************************************************************************
  Cdd::lock

	return :
		NULL if an error occurred
		addr : address of screen if all is OK
 **************************************************************************/
void *Cdd::lock()
{
/*
  _ASSERT(m_beginrendercount==0);
  HRESULT err;
  DDSURFACEDESC2 ddsd;
  ddsd.dwSize=sizeof(ddsd);
  err=m_backbuffer->Lock(NULL,&ddsd,DDLOCK_WAIT,NULL);
  if(err!=D3D_OK)
  {
	  DDERROR(err);
  }
  return((void *)ddsd.lpSurface);
*/
	return NULL;
}

/**************************************************************************
  Cdd::unlock
 **************************************************************************/
int Cdd::unLock(void)
{
/*	_ASSERT(m_beginrendercount==0);
	HRESULT err;
	if(!ready()) 
		return(FALSE);
	err=m_backbuffer->Unlock(NULL);
	if(err!=D3D_OK)
	{
		  DDERROR(err);
	}
*/
	return (TRUE);
}

UD Cdd::rgbTransform(Crgb rgb)
{
	UD r,g,b;
	r=rgb.getr();
	g=rgb.getg();
	b=rgb.getb();
	r>>=(8-m_rbitcount);
	g>>=(8-m_gbitcount);
	b>>=(8-m_bbitcount);
	r<<=m_rshift;
	g<<=m_gshift;
	b<<=m_bshift;
	r&=m_rmask;
	g&=m_gmask;
	b&=m_bmask;
	return(r | g | b);
}

BOOL Cdd::fillRectangle(int x1,int y1,int x2,int y2,Cuv const &a,Cuv const &b,BNKIDX bank,Crgb const &color,Crgb const &specular)
{
	_ASSERT(m_beginrendercount==1);
	_ASSERT(x1>=m_fwinx1);
	_ASSERT(y1>=m_fwiny1);
	_ASSERT(x1<=m_fwinx2);
	_ASSERT(y1<=m_fwiny2);
	_ASSERT(x2>=m_fwinx1);
	_ASSERT(y2>=m_fwiny1);
	_ASSERT(x2<=m_fwinx2);
	_ASSERT(y2<=m_fwiny2);

	Cgvtx srcv[4];

	srcv[0].v2d.x=(float)(x1);
	srcv[0].v2d.y=(float)(y1);
	srcv[0].uv.u=a.getu();
	srcv[0].uv.v=a.getv();
	srcv[0].iz=1.0F;
	srcv[0].z=1.0F;
	srcv[0].rgbcolor=color.rgba;
	srcv[0].rgbspecular=specular.rgba;

	srcv[1].v2d.x=(float)(x2);
	srcv[1].v2d.y=(float)(y1);
	srcv[1].uv.u=b.getu();
	srcv[1].uv.v=a.getv();
	srcv[1].iz=1.0F;
	srcv[1].z=1.0F;
	srcv[1].rgbcolor=color.rgba;
	srcv[1].rgbspecular=specular.rgba;

	srcv[2].v2d.x=(float)(x2);
	srcv[2].v2d.y=(float)(y2);
	srcv[2].uv.u=b.getu();
	srcv[2].uv.v=b.getv();
	srcv[2].iz=1.0F;
	srcv[2].z=1.0F;
	srcv[2].rgbcolor=color.rgba;
	srcv[2].rgbspecular=specular.rgba;

	srcv[3].v2d.x=(float)(x1);
	srcv[3].v2d.y=(float)(y2);
	srcv[3].uv.u=a.getu();
	srcv[3].uv.v=b.getv();
	srcv[3].iz=1.0F;
	srcv[3].z=1.0F;
	srcv[3].rgbcolor=color.rgba;
	srcv[3].rgbspecular=specular.rgba;

	dd_Triangle(ATTR_TEXTURED,&srcv[0],&srcv[1],&srcv[2],bank);
	dd_Triangle(ATTR_TEXTURED,&srcv[0],&srcv[2],&srcv[3],bank);
	return TRUE;
}

BOOL Cdd::fillRectangle(int x1,int y1,int x2,int y2,Crgb color)
{
	_ASSERT(m_beginrendercount==1);
	_ASSERT(x1>=m_fwinx1);
	_ASSERT(y1>=m_fwiny1);
	_ASSERT(x1<=m_fwinx2);
	_ASSERT(y1<=m_fwiny2);
	_ASSERT(x2>=m_fwinx1);
	_ASSERT(y2>=m_fwiny1);
	_ASSERT(x2<=m_fwinx2);
	_ASSERT(y2<=m_fwiny2);
	Cgvtx srcv[4];

	srcv[0].v2d.x=(float)(x1);
	srcv[0].v2d.y=(float)(y1);
	srcv[0].iz=1.0F;
	srcv[0].z=1.0F;
	srcv[0].rgbcolor=color.getrgba();
	srcv[0].rgbspecular=0x00000000;

	srcv[1].v2d.x=(float)(x2);
	srcv[1].v2d.y=(float)(y1);
	srcv[1].iz=1.0F;
	srcv[1].z=1.0F;
	srcv[1].rgbcolor=color.getrgba();
	srcv[1].rgbspecular=0x00000000;

	srcv[2].v2d.x=(float)(x2);
	srcv[2].v2d.y=(float)(y2);
	srcv[2].iz=1.0F;
	srcv[2].z=1.0F;
	srcv[2].rgbcolor=color.getrgba();
	srcv[2].rgbspecular=0x00000000;

	srcv[3].v2d.x=(float)(x1);
	srcv[3].v2d.y=(float)(y2);
	srcv[3].iz=1.0F;
	srcv[3].z=1.0F;
	srcv[3].rgbcolor=color.getrgba();
	srcv[3].rgbspecular=0x00000000;

	dd_Triangle(0,&srcv[0],&srcv[1],&srcv[2],0);
	dd_Triangle(0,&srcv[0],&srcv[2],&srcv[3],0);
	return TRUE;
}

/*
{
	DDBLTFX ddbltfx;
	RECT	r;
	HRESULT err;
	r.left=x1; 
	r.top=y1; 
	r.right=x2;
	r.bottom=y2;
	ddbltfx.dwSize=sizeof(ddbltfx);
	ddbltfx.dwFillColor=rgbtransform(color);
	err=m_backbuffer->Blt(
		&r,
		NULL,
		NULL,
		DDBLT_COLORFILL | DDBLT_WAIT,
		&ddbltfx);
    return(err==D3D_OK);
}
*/



void Cdd::error(int dderror,char *msgerror,BOOL stopprogram)
{
	char msg[512];
	char *ddmsg;
    if( dderror!=D3D_OK )
    {
	    sprintf(msg,"Err:0x%08x",dderror);
    }
    else
    {
		sprintf(msg,"");
    }
	ddmsg=(char *)DXGetErrorString8(dderror);
	sprintf(msg,"%s : %s",msg,msgerror);
	if(stopprogram)
	{
		releaseAllTexture();
		releaseAll();
//DX8?		destroydirectdraw();
//DX8?		if(m_fullscreen)
//DX8?		{
//DX8?			m_dd->SetCooperativeLevel(m_hwnd,DDSCL_NORMAL);
//DX8?		}
	}
	MessageBox(
		m_hwnd,
		msg,
		"Direct Draw Error",
		MB_OK
		);
	if(stopprogram)
	{
		exit(0);
	}
}


void Cdd::clearStats(void)
{
	m_trianglecount=0;
	m_updaterenderstatecount=0;
	m_drawprimitivecount=0;
	m_setstatecount=0;
	m_settexturestagecount=0;
}

BOOL Cdd::continueRender(void)
{
	_ASSERT(m_beginrendercount==0);
	HRESULT err;
	m_trianglevertexcount=0;
	m_linevertexcount=0;

    err=m_trianglevertexbuffer8->Lock(0,sizeof(CddTlVertex),(unsigned char **)(&m_trianglevertex),0);
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}
    err=m_linevertexbuffer8->Lock(0,sizeof(CddTlLineVertex),(unsigned char **)(&m_linevertex),0);
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}

	err=m_device->BeginScene();
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}
    err=m_device->SetStreamSource(0,m_trianglevertexbuffer8,sizeof(CddTlVertex) );
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}
	err=m_device->SetVertexShader(D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_SPECULAR|D3DFVF_TEX2);
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}
	m_beginrendercount=1;
	return err==D3D_OK;
}

BOOL Cdd::beginRender(BOOL clearzbuffer,BOOL cleartarget,BOOL clearstencil,float zbuffer,Crgb color,unsigned int stencil)
{
	_ASSERT(m_beginrendercount==0);
	if(m_device)
	{
		clear(clearzbuffer,cleartarget,clearstencil,zbuffer,color,stencil);
		if(continueRender())
		{
			initRenderState();
			initRenderStage();
			return TRUE;
		}
	}
	m_beginrendercount=0;
	return FALSE;
}



void Cdd::stopRender(void)
{
	_ASSERT(m_beginrendercount==1);
	HRESULT err;
	flushAll();
	err=m_device->SetTexture(0,NULL);
    if(err!=D3D_OK)
	{
		DDERROR(err);
    }
	if(m_texturestagemax>1)
	{
		err=m_device->SetTexture(1,NULL);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		if(m_texturestagemax>2)
		{
			err=m_device->SetTexture(2,NULL);
			if(err!=D3D_OK)
			{
				DDERROR(err);
			}
		}
	}
    err=m_trianglevertexbuffer8->Unlock();
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}
    err=m_linevertexbuffer8->Unlock();
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}
	err=m_device->EndScene();
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}
	m_beginrendercount=0;
}

	struct CUSTOMVERTEX
	{
		FLOAT x, y, z, rhw; // The transformed translation for the vertex
		DWORD color;        // The vertex color
	};

void Cdd::endRender(void)
{
	_ASSERT(m_beginrendercount==1);
	stopRender();
	m_beginrendercount=0;
}


void Cdd::initRenderStage(void)
{
	dd_SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_DISABLE);
	// default setting for STAGE 1
	if(m_texturestagemax>1)
	{
		dd_SetTextureStageState(1,D3DTSS_COLORARG1,D3DTA_TEXTURE );
		dd_SetTextureStageState(1,D3DTSS_COLORARG2,D3DTA_CURRENT );
		dd_SetTextureStageState(1,D3DTSS_ALPHAARG1,D3DTA_TEXTURE );
		dd_SetTextureStageState(1,D3DTSS_ALPHAARG2,D3DTA_CURRENT );
		dd_SetTextureStageState(1,D3DTSS_ADDRESSW,D3DTADDRESS_WRAP );
		if(m_texturestagemax>2)
		{
			dd_SetTextureStageState(1,D3DTSS_BUMPENVMAT00,FLOATtoDWORD(1.0F));
			dd_SetTextureStageState(1,D3DTSS_BUMPENVMAT01,FLOATtoDWORD(0.0F));
			dd_SetTextureStageState(1,D3DTSS_BUMPENVMAT10,FLOATtoDWORD(0.0F));
			dd_SetTextureStageState(1,D3DTSS_BUMPENVMAT11,FLOATtoDWORD(1.0F));
			dd_SetTextureStageState(1,D3DTSS_BUMPENVLSCALE,FLOATtoDWORD(1.0F));
			dd_SetTextureStageState(1,D3DTSS_BUMPENVLOFFSET,FLOATtoDWORD(0.0F));
			// default setting for STAGE 2
			dd_SetTextureStageState(2,D3DTSS_COLORARG1,D3DTA_TEXTURE );
			dd_SetTextureStageState(2,D3DTSS_COLORARG2,D3DTA_CURRENT );
			dd_SetTextureStageState(2,D3DTSS_ALPHAARG1,D3DTA_TEXTURE );
			dd_SetTextureStageState(2,D3DTSS_ALPHAARG2,D3DTA_CURRENT );
			dd_SetTextureStageState(2,D3DTSS_ADDRESSW,D3DTADDRESS_WRAP );
		}
	}
	// flat render (not textured)
	// default setting for STAGE 0 
	dd_SetTextureStageState(0,D3DTSS_TEXCOORDINDEX, 0 );
	dd_SetTextureStageState(0,D3DTSS_COLORARG1,D3DTA_TEXTURE );
	dd_SetTextureStageState(0,D3DTSS_COLORARG2,D3DTA_DIFFUSE );
	dd_SetTextureStageState(0,D3DTSS_COLOROP, D3DTOP_SELECTARG2 );

	dd_SetTextureStageState(0,D3DTSS_ALPHAARG1,D3DTA_TEXTURE );
	dd_SetTextureStageState(0,D3DTSS_ALPHAARG2,D3DTA_DIFFUSE );
	dd_SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_SELECTARG2);
	
	dd_SetTextureStageState(0,D3DTSS_ADDRESSW,D3DTADDRESS_WRAP );

	// disable stage 1
	dd_SetTextureStageState(1,D3DTSS_COLOROP,D3DTOP_DISABLE );
	dd_SetTextureStageState(1,D3DTSS_ALPHAOP,D3DTOP_DISABLE );
}



void Cdd::initRenderState(void)
{
	// no switch
	m_oldattrib=0;
	m_oldbank=0xFFFFFFFF;
	#if DIRECTDRAW_VERSION>=0x700
		dd_State(D3DRS_CLIPPLANEENABLE,0);
	#endif
	// z buffer
	setRenderZbuffer(m_renderzbuffer,TRUE);
	// dithering
	setRenderDither(m_renderdither,TRUE);
	// fog
	setRenderFog(m_renderfog,TRUE);
	setRenderFogColor(m_renderfogcolor,TRUE);
	// init filter state
	setRenderFilter(m_renderfilter,TRUE);
	// init mipmap state
	setRenderMipmap(m_rendermipmap,TRUE);
	// disable clipping and lightning
	#if DIRECTDRAW_VERSION>=0x700
		#ifdef DDCLIPPING
			dd_State(D3DRS_CLIPPING,FALSE);
		#else
			dd_State(D3DRS_CLIPPING,TRUE);
		#endif
//DX8?		dd_State(D3DRS_EXTENTS,FALSE);
		dd_State(D3DRS_LIGHTING,FALSE);
	#endif
	// no culling
	dd_State(D3DRS_CULLMODE,D3DCULL_NONE);
	// solid mode by default
	dd_State(D3DRS_FILLMODE,D3DFILL_SOLID);
	// specular
	dd_State(D3DRS_SPECULARENABLE,TRUE);
	// alpha test
	dd_State(D3DRS_ALPHATESTENABLE,FALSE);
	dd_State(D3DRS_ALPHAFUNC,D3DCMP_GREATER);
	dd_State(D3DRS_ALPHAREF,0x00000000);
	// flat shading
	dd_State(D3DRS_SHADEMODE,D3DSHADE_FLAT);
	// not translucide
  	dd_State(D3DRS_ALPHABLENDENABLE,FALSE);
    dd_State(D3DRS_SRCBLEND,D3DBLEND_ONE);
  	dd_State(D3DRS_DESTBLEND,D3DBLEND_ZERO);
}

void Cdd::switchRenderStateReflection(BOOL flag)
{
	if(m_oldbank!=0xFFFFFFFF)
	{
		HRESULT err;
		_ASSERT(m_beginrendercount==1);
		// translucide
		if(flag)
		{
			updateRenderState(ATTR_TEXTURED|ATTR_GOURAUD|ATTR_TRANSLUCIDE);
			int idxcache=DD_GETCACHEIDX2(m_oldbank);
			err=m_device->SetTexture(0,m_texture[idxcache].texture);
			if(err!=D3D_OK)
			{
				DDERROR(err);
			}
		}
		else
		{
			int idxcache=DD_GETCACHEIDX1(m_oldbank);
			err=m_device->SetTexture(0,m_texture[idxcache].texture );
			if(err!=D3D_OK)
			{
				DDERROR(err);
			}
		}
	}
}

void Cdd::updateRenderState(SIDEATTR attrib)
{
	_ASSERT(m_beginrendercount==1);
	SIDEATTR changedattrib;
	changedattrib=m_oldattrib ^ attrib;
	if(changedattrib)
	{
		int maxstage=0;
		m_updaterenderstatecount++;
		// wire
		if(changedattrib & ATTR_WIRE)
		{
			if(attrib & ATTR_WIRE)
			{
				dd_State(D3DRS_FILLMODE,D3DFILL_WIREFRAME);
			}
			else
			{
				dd_State(D3DRS_FILLMODE,D3DFILL_SOLID);
			}
		}
		//gouraud
		if(changedattrib & ATTR_GOURAUD)
		{
			if(attrib & ATTR_GOURAUD)
			{
				dd_State(D3DRS_SHADEMODE,D3DSHADE_GOURAUD);
			}
			else
			{
				dd_State(D3DRS_SHADEMODE,D3DSHADE_FLAT);
			}
		}
		// translucide
		if(changedattrib & ATTR_ALLTRANSLUCIDE)
		{
			if(attrib & ATTR_ALLTRANSLUCIDE)
			{

				dd_State(D3DRS_ZWRITEENABLE,FALSE);
  				dd_State(D3DRS_ALPHABLENDENABLE,TRUE);
				if(attrib & ATTR_TRANSLUCIDEMOD)
				{
    				dd_State(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
    				dd_State(D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA);
				}
				else
				{
    				dd_State(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
    				dd_State(D3DRS_DESTBLEND,D3DBLEND_ONE);
				}

			}
			else
			{
				dd_State(D3DRS_ZWRITEENABLE,m_renderzbuffer);
  				dd_State(D3DRS_ALPHABLENDENABLE,FALSE);
    			dd_State(D3DRS_SRCBLEND,D3DBLEND_ONE);
  				dd_State(D3DRS_DESTBLEND,D3DBLEND_ZERO);
				dd_SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_DISABLE);
			}
		}
		// textured
		if(changedattrib & ATTR_TEXTURED)
		{
			if(attrib & ATTR_TEXTURED)
			{
				dd_SetTextureStageState(0,D3DTSS_COLORARG1,D3DTA_TEXTURE );
				dd_SetTextureStageState(0,D3DTSS_COLORARG2,D3DTA_DIFFUSE );
				dd_SetTextureStageState(0,D3DTSS_COLOROP,D3DTOP_MODULATE );
				if(attrib & (ATTR_TRANSLUCIDE))
					dd_SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_MODULATE);
				else
					dd_SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_DISABLE);
				dd_SetTextureStageState(0,D3DTSS_TEXCOORDINDEX, 0 );
			}
			else
			{
				dd_SetTextureStageState(0,D3DTSS_COLOROP, D3DTOP_SELECTARG2 );
				dd_SetTextureStageState(0,D3DTSS_ALPHAOP, D3DTOP_SELECTARG2 );
			}
		}
		// transparent
		if(changedattrib & (ATTR_TRANSPARENT))
		{
			if(attrib & ATTR_TRANSPARENT)
			{
				dd_State(D3DRS_ALPHATESTENABLE,TRUE);
				dd_SetTextureStageState(0,D3DTSS_ALPHAOP,D3DTOP_SELECTARG1);
   			}
			else
			{
				dd_State(D3DRS_ALPHATESTENABLE,FALSE);
			}
		}
		// now take care of next render stage
		if(changedattrib & (ATTR_BUMP|ATTR_REFLECTION))
		{
			if((attrib & ATTR_BUMP) && (m_texturestagemax>2))
			{
				// Bump Texture
				dd_SetTextureStageState(1, D3DTSS_TEXCOORDINDEX, 0 );
				dd_SetTextureStageState(1, D3DTSS_COLOROP, D3DTOP_BUMPENVMAP );
				dd_SetTextureStageState(2, D3DTSS_ADDRESSW, D3DTADDRESS_WRAP );
				dd_SetTextureStageState(2, D3DTSS_TEXCOORDINDEX, 1 );
				dd_SetTextureStageState(2, D3DTSS_COLOROP, D3DTOP_ADD );
				maxstage=2;
			}
			else
			{

				if(attrib & ATTR_REFLECTION)
				{
					if(m_texturestagemax>1)
					{
						dd_SetTextureStageState(1,D3DTSS_TEXCOORDINDEX,1);
						dd_SetTextureStageState(1,D3DTSS_COLOROP,D3DTOP_ADD );
						maxstage=1;
					}
				}
			}
		}
		dd_SetTextureStageState(maxstage+1,D3DTSS_COLOROP,D3DTOP_DISABLE );
		dd_SetTextureStageState(maxstage+1,D3DTSS_ALPHAOP,D3DTOP_DISABLE );
		m_oldattrib=attrib;

		//unsigned long count;
		//HRESULT err=m_device->ValidateDevice(&count);
		//if(err!=D3D_OK)
		{
		//	DDERROR(err);
		}
	}
}


void Cdd::updateRenderBank(SIDEATTR attrib,BNKIDX bank)
{
	HRESULT err;
	_ASSERT(m_beginrendercount==1);
	if(bank==0xFFFFFFFF)
	{
		m_oldbank=bank;
		err=m_device->SetTexture(0,NULL);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		return;
		err=m_device->SetTexture(1,NULL);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		return;
	}
	if(m_oldbank!=bank)
	{
		err=m_device->SetTexture(0,m_texture[DD_GETCACHEIDX1(bank)].texture );
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		if((attrib & ATTR_BUMP) && (m_texturestagemax>2))
		{
			err=m_device->SetTexture(1,m_texture[DD_GETCACHEIDX3(bank)].texture );
			if(err!=D3D_OK)
			{
				DDERROR(err);
			}
			err=m_device->SetTexture(2,m_texture[DD_GETCACHEIDX2(bank)].texture );
			if(err!=D3D_OK)
			{
				DDERROR(err);
			}
		}
		else
		{
			if(attrib & ATTR_REFLECTION)
			{
				if(m_texturestagemax>1)
				{
					err=m_device->SetTexture(1,m_texture[DD_GETCACHEIDX2(bank)].texture );
					if(err!=D3D_OK)
					{
						DDERROR(err);
					}
				}
			}
			else
			{
					err=m_device->SetTexture(1,NULL);
			}
		}
		m_oldbank=bank;
	}
}

void Cdd::dd_State(D3DRENDERSTATETYPE state,UD value)
{
	m_device->SetRenderState(state,value);
	m_setstatecount++;
}
void Cdd::dd_SetTextureStageState(DWORD dwstage,D3DTEXTURESTAGESTATETYPE dwstate,DWORD dwvalue)
{
	m_device->SetTextureStageState(dwstage,dwstate,dwvalue);
	m_settexturestagecount++;
}

void Cdd::dd_Line(Cgvtx *a,Cgvtx *b)
{
	if(m_linevertexcount+2>=DD_LINEVERTEXMAX)
	{
		flushAll();
	}
	CddTlLineVertex *linevertex=&m_linevertex[m_linevertexcount];
	linevertex[0].m_sx=a->v2d.x;
	linevertex[0].m_sy=a->v2d.y;
	linevertex[0].m_sz=m_nearplane_divmaxz;
	linevertex[0].m_rhw=m_invnearplane_divmaxz;
	linevertex[0].m_color=a->rgbcolor;
	linevertex[0].m_specular=0;
	linevertex[1].m_sx=b->v2d.x;
	linevertex[1].m_sy=b->v2d.y;
	linevertex[1].m_sz=m_nearplane_divmaxz;
	linevertex[1].m_rhw=m_invnearplane_divmaxz;
	linevertex[1].m_color=b->rgbcolor;
	linevertex[1].m_specular=0;
	m_linevertexcount+=2;
}

void Cdd::flushTriangle(void)
{
	HRESULT err;
	_ASSERT(m_beginrendercount==1);
	if(m_trianglevertexcount>0)
	{
		m_trianglecount+=m_trianglevertexcount/3;
		m_drawprimitivecount++;
		err=m_trianglevertexbuffer8->Unlock();
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		err=m_device->DrawPrimitive
			(
			D3DPT_TRIANGLELIST,
			0,
			m_trianglevertexcount/3
			);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		err=m_trianglevertexbuffer8->Lock(0,sizeof(CddTlVertex),(unsigned char **)(&m_trianglevertex),0);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		if(m_oldattrib & ATTR_REFLECTION)
		{
			if(m_texturestagemax<=1)
			{
				m_trianglecount+=m_trianglevertexcount/3;
				switchRenderStateReflection(TRUE);
				m_drawprimitivecount++;
				for(int i=0;i<m_trianglevertexcount;i++)
				{
					m_trianglevertex[i].m_tu=m_trianglevertex[i].m_tu2;
					m_trianglevertex[i].m_tv=m_trianglevertex[i].m_tv2;
					m_trianglevertex[i].m_rgbcolor=0xFFFFFFFF;
					m_trianglevertex[i].m_specular=0x0;
				}
				err=m_trianglevertexbuffer8->Unlock();
				if(err!=D3D_OK)
				{
					DDERROR(err);
				}
				err=m_device->DrawPrimitive
					(
					D3DPT_TRIANGLELIST,
					0,
					m_trianglevertexcount/3
					);
				if(err!=D3D_OK)
				{
					DDERROR(err);
				}
				err=m_trianglevertexbuffer8->Lock(0,sizeof(CddTlVertex),(unsigned char **)(&m_trianglevertex),0);
				if(err!=D3D_OK)
				{
					DDERROR(err);
				}
				switchRenderStateReflection(FALSE);
			}
		}
		m_trianglevertexcount=0;
	}
}


void Cdd::flushLine(void)
{
	HRESULT err;
	_ASSERT(m_beginrendercount==1);
	if(m_linevertexcount>0)
	{
		updateRenderState(ATTR_GOURAUD);
		updateRenderBank(ATTR_GOURAUD,0xFFFFFFFF);
		// on line stream source
		err=m_device->SetStreamSource(0,m_linevertexbuffer8,sizeof(CddTlLineVertex) );
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		err=m_device->SetVertexShader(D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_SPECULAR);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		// unlock
		err=m_linevertexbuffer8->Unlock();
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		err=m_device->DrawPrimitive
			(
			D3DPT_LINELIST,
			0,
			m_linevertexcount/2
			);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		err=m_linevertexbuffer8->Lock(0,sizeof(CddTlLineVertex),(unsigned char **)(&m_linevertex),0);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		// again on triangle stream source
		err=m_device->SetStreamSource(0,m_trianglevertexbuffer8,sizeof(CddTlVertex) );
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		err=m_device->SetVertexShader(D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_SPECULAR|D3DFVF_TEX2);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
		m_linevertexcount=0;
	}
}


void Cdd::flushAll(void)
{
	flushTriangle();
	flushLine();
}

void Cdd::dd_Triangle(SIDEATTR attrib,Cgvtx *a,Cgvtx *b,Cgvtx *c,BNKIDX bank)
{
	_ASSERT(m_beginrendercount==1);
	if(m_trianglevertexcount+3>=DD_TRIANGLEVERTEXMAX || attrib!=m_oldattrib || bank!=m_oldbank )
	{
		flushTriangle();
		updateRenderState(attrib);
		updateRenderBank(attrib,bank);
	}
	CddTlVertex *d3dvertex=&m_trianglevertex[m_trianglevertexcount];
	memcpy(&d3dvertex[0],a,sizeof(CddTlVertex));
	memcpy(&d3dvertex[1],b,sizeof(CddTlVertex));
	memcpy(&d3dvertex[2],c,sizeof(CddTlVertex));
	m_trianglevertexcount+=3;
}

void Cdd::dd_Polygon(SIDEATTR attrib,Cgvtx **pts,int ptscount,BNKIDX bank)
{
//	HRESULT err;
	if(m_oldattrib!=attrib || m_oldbank!=bank)
	{
		flushTriangle();
		updateRenderState(attrib);
		updateRenderBank(attrib,bank);
	}
	CddTlVertex d3dvertex[16];
	for(int i=0;i<ptscount;i++)
	{
		_ASSERT(pts[i]->v2d.x>=m_fwinx1 && pts[i]->v2d.x<=m_fwinx2);
		_ASSERT(pts[i]->v2d.y>=m_fwiny1 && pts[i]->v2d.y<=m_fwiny2);
		memcpy(&d3dvertex[i],pts[i],sizeof(CddTlVertex));
	}
	m_drawprimitivecount++;
/*DX8?
	err=m_device->DrawPrimitive
	(
		D3DPT_TRIANGLEFAN,
		D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_SPECULAR|D3DFVF_TEX2,
		(LPVOID)d3dvertex,
		ptscount,
		DDEX_PRIMITIVEFLAG
	);
	if(err!=D3D_OK)
	{
		DDERROR(err);
	}
*/
	if(m_oldattrib & ATTR_REFLECTION)
	{
		if(m_texturestagemax<=1)
		{
			switchRenderStateReflection(TRUE);
			m_drawprimitivecount++;
			for(int i=0;i<ptscount;i++)
			{
				d3dvertex[i].m_tu=d3dvertex[i].m_tu2;
				d3dvertex[i].m_tv=d3dvertex[i].m_tv2;
			}
			m_trianglecount+=ptscount-2;
			ASSERT(ptscount>=3);
/*DX8?
			err=m_device->DrawPrimitive
			(
			D3DPT_TRIANGLEFAN,
			D3DFVF_XYZRHW|D3DFVF_DIFFUSE|D3DFVF_SPECULAR|D3DFVF_TEX2,
			(LPVOID)d3dvertex,
			ptscount,
			DDEX_PRIMITIVEFLAG
			);
			if(err!=D3D_OK)
			{
				DDERROR(err);
			}
*/
			switchRenderStateReflection(FALSE);
		}
	}
	m_trianglecount+=ptscount-2;
}


#define EDGECOMPUTE(ATTRIB,AXIS,COMPARE,CLIPOFFSET,TAB1,TAB2,TAB1COUNT,TAB2COUNT)\
{\
	int i=0;\
	TAB2COUNT=0;\
	while(i<TAB1COUNT)\
	{\
		if(TAB1[i]->AXIS COMPARE (CLIPOFFSET))\
		{\
			TAB2[TAB2COUNT++]=TAB1[i];\
			_ASSERT(TAB2COUNT<DD_GVTXMAX);\
			if(!(TAB1[i+1]->AXIS COMPARE (CLIPOFFSET)))\
			{\
				float ratio;\
				ratio=(TAB1[i]->AXIS-(CLIPOFFSET))/(TAB1[i]->AXIS-TAB1[i+1]->AXIS);\
				_ASSERT(src_vbuffercount<DD_GVTXMAX);\
				TAB2[TAB2COUNT]=&src_vbuffer[src_vbuffercount++];\
				TAB2[TAB2COUNT]->set(ATTRIB,TAB1[i],TAB1[i+1],ratio);\
				TAB2[TAB2COUNT]->AXIS=CLIPOFFSET;\
				TAB2COUNT++;\
				_ASSERT(TAB2COUNT<DD_GVTXMAX);\
			}\
		}\
		else\
		{\
			if(TAB1[i+1]->AXIS COMPARE (CLIPOFFSET))\
			{\
				float ratio;\
				ratio=(TAB1[i+1]->AXIS-(CLIPOFFSET))/(TAB1[i+1]->AXIS-TAB1[i]->AXIS);\
				_ASSERT(src_vbuffercount<DD_GVTXMAX);\
				TAB2[TAB2COUNT]=&src_vbuffer[src_vbuffercount++];\
				TAB2[TAB2COUNT]->set(ATTRIB,TAB1[i+1],TAB1[i],ratio);\
				TAB2[TAB2COUNT]->AXIS=CLIPOFFSET;\
				TAB2COUNT++;\
				_ASSERT(TAB2COUNT<DD_GVTXMAX);\
			}\
		}\
		i++;\
	}\
	TAB2[TAB2COUNT]=TAB2[0];\
}\


void Cdd::line(Cgvtx a,Cgvtx b)
{
	if(clipinwindow(&a.v2d.x,&a.v2d.y,&b.v2d.x,&b.v2d.y,m_fwinx1,m_fwiny1,m_fwinx2,m_fwiny2))
	{
		dd_Line(&a,&b);
	}
}

void Cdd::line(Cv2d a,Cv2d b,Crgb color)
{
	Cgvtx ga;
	Cgvtx gb;
	ga.v2d=a;
	ga.rgb=color;
	gb.v2d=b;
	gb.rgb=color;
	line(ga,gb);
}

void Cdd::xEdgeCompute(SIDEATTR attrib)
{
	EDGECOMPUTE(attrib,v2d.x,>=,m_fwinx1,src_v1addr,src_v2addr,src_v1count,src_v2count);
	EDGECOMPUTE(attrib,v2d.x,<=,m_fwinx2,src_v2addr,src_v1addr,src_v2count,src_v1count);
}

void Cdd::yEdgeCompute(SIDEATTR attrib)
{
	EDGECOMPUTE(attrib,v2d.y,>=,m_fwiny1,src_v1addr,src_v2addr,src_v1count,src_v2count);
	EDGECOMPUTE(attrib,v2d.y,<=,m_fwiny2,src_v2addr,src_v1addr,src_v2count,src_v1count);
}


void Cdd::triangle(SIDEATTR attrib,Cgvtx *a,Cgvtx *b,Cgvtx *c,BNKIDX bank)
{
#ifdef DDCLIPPING
	UB xclip=(UB)(a->clipx|b->clipx|c->clipx);
	UB yclip=(UB)(a->clipy|b->clipy|c->clipy);
	if(xclip|yclip)
	{
		//prepare clipping buffer 1
		src_vbuffercount=0;
		src_v1count=3;
		src_v1addr[0]=a;
		src_v1addr[1]=b;
		src_v1addr[2]=c;
		src_v1addr[3]=a;
		if(xclip)
		{
			xEdgeCompute(attrib);
		}
		if(src_v1count>=3 && yclip)
		{
			yEdgeCompute(attrib);
		}
		if(src_v1count>=3)
		{
			for(int i=1;i<src_v1count-1;i++)
			{
				dd_Triangle(attrib,src_v1addr[0],src_v1addr[i],src_v1addr[i+1],bank);
			}
		}
		return;
	}
#endif
	dd_Triangle(attrib,a,b,c,bank);
}



void Cdd::quad(SIDEATTR attrib,Cgvtx *a,Cgvtx *b,Cgvtx *c,Cgvtx *d,BNKIDX bank)
{
#ifdef DDCLIPPING
	UB xclip=(UB)(a->clipx|b->clipx|c->clipx|d->clipx);
	UB yclip=(UB)(a->clipy|b->clipy|c->clipy|d->clipy);
	if(xclip|yclip)
	{
		//prepare clipping buffer 1
		src_v1addr[0]=a;
		src_v1addr[1]=b;
		src_v1addr[2]=c;
		src_v1addr[3]=d;
		src_v1count=4;
		src_vbuffercount=0;
		src_v1addr[4]=a;
		if(xclip)
		{
			xEdgeCompute(attrib);
		}
		if(src_v1count>=3 && yclip)
		{
			yEdgeCompute(attrib);
		}
		if(src_v1count>=3)
		{
			for(int i=1;i<src_v1count-1;i++)
			{
				dd_Triangle(attrib,src_v1addr[0],src_v1addr[i],src_v1addr[i+1],bank);
			}
		}
		return;
	}
#endif
	dd_Triangle(attrib,a,b,c,bank);
	dd_Triangle(attrib,a,c,d,bank);
}

void Cdd::pent(SIDEATTR attrib,Cgvtx *a,Cgvtx *b,Cgvtx *c,Cgvtx *d,Cgvtx *e,BNKIDX bank)
{
#ifdef DDCLIPPING
	UB xclip=(UB)(a->clipx|b->clipx|c->clipx|d->clipx|e->clipx);
	UB yclip=(UB)(a->clipy|b->clipy|c->clipy|d->clipy|e->clipy);
	if(xclip|yclip)
	{
		//prepare clipping buffer 1
		src_vbuffercount=0;
		src_v1addr[0]=a;
		src_v1addr[1]=b;
		src_v1addr[2]=c;
		src_v1addr[3]=d;
		src_v1addr[4]=e;
		src_v1count=5;
		src_v1addr[5]=a;
		if(xclip)
		{
			xEdgeCompute(attrib);
		}
		if(src_v1count>=3 && yclip)
		{
			yEdgeCompute(attrib);
		}
		if(src_v1count>=3)
		{
			for(int i=1;i<src_v1count-1;i++)
			{
				dd_Triangle(attrib,src_v1addr[0],src_v1addr[i],src_v1addr[i+1],bank);
			}
		}
		return;
	}
#endif
	dd_Triangle(attrib,a,b,c,bank);
	dd_Triangle(attrib,a,c,d,bank);
	dd_Triangle(attrib,a,d,e,bank);
}


void Cdd::putPixel(int x,int y,Crgb color,BNKIDX bank)
{
#if 0
    DDSURFACEDESC2 ddsd;
	unsigned short *ptr=NULL;
	if(m_texture[bank].texture)
	{
//DX8?		if(x>=0 && x<(int)m_texture[bank].ddsd.dwWidth && y>=0 && y<(int)m_texture[bank].ddsd.dwHeight)
		{
			memset(&ddsd,0,sizeof(ddsd));
			ddsd.dwSize = sizeof(ddsd);
			if(m_texture[bank].texture->Lock(NULL,&ddsd,DDLOCK_WAIT|DDLOCK_WRITEONLY,NULL)==D3D_OK)
			{
				ptr=(unsigned short *)((unsigned char *)(ddsd.lpSurface)+ddsd.lPitch*y+x*2);
				*ptr=0xFFFF;
				m_texture[bank].texture->Unlock(NULL);
			}
		}
	}
#endif
}

void Cdd::releaseAllTexture(void)
{
	outputdebug("CDD::releasealltexture:begin-----------------------\n");
	int cnt;
	int countrelease=0;
	for(int n=0;n<DD_TEXTUREMAX;n++)
	{
		if(m_texture[n].texture)
		{
			// releasing level of texture
			
			int levelcount=m_texture[n].texture->GetLevelCount();
			outputdebug("releasing texture %d (%d mipmap) -> ",n,levelcount);
			IDirect3DSurface8 * surfacelevel;
			for (int level=levelcount-1;level>=0;level--)
			{
				m_texture[n].texture->GetSurfaceLevel(level,&surfacelevel);
				int cnt;
				cnt=surfacelevel->Release();
				outputdebug("%d ",cnt);
			}
			cnt=m_texture[n].texture->Release();
			m_texture[n].texture=NULL;
			outputdebug(" cntref %d\n",cnt);
			countrelease++;
		}
	}
	outputdebug("CDD::releasealltexture--------------------------:%d released\n",countrelease);
	if(m_d3d)
	{
	}
	
}

BOOL Cdd::loadTexture(int n,char *name,BOOL isbump)
{
	unsigned int level;
	int mipmapcount=0;
	int levelcount=0;
	//if(n==-7878)

	if(m_rendermipmap==DD_MIPMAP_NONE)
	{
		mipmapcount=1;
	}
	else
	{
		mipmapcount=0;
	}

	_ASSERT(m_beginrendercount==0);
	Ctga tga;
	HRESULT err;
	_ASSERT(n>=0 && n<=DD_TEXTUREMAX);
	// release the texture
	if(isbump)
	{
		outputdebug("CDD::loadbump:%d %s\n",n,name);
	}
	else
	{
		outputdebug("CDD::loadtext:%d %s\n",n,name);
	}
	if(m_texture[n].texture)
	{
		int cnt;
		cnt=m_texture[n].texture->Release();
		m_texture[n].texture=NULL;

	}
    strcpy(m_texture[n].filename,name);
	// load the texture
	if(!tga.load(m_texture[n].filename))
	{
		outputdebug("CDD::loadtexture:%s file doesn't exist\n",name);
		return FALSE;
	}

	int neww=tga.getW();
	int newh=tga.getH();
	if(neww<getMinTextureW())
	{
		neww=getMinTextureW();
	}
	if(neww>getMaxTextureW())
	{
		neww=getMaxTextureW();
	}
	if(newh<getMinTextureH())
	{
		newh=getMinTextureH();
	}
	if(newh>getMaxTextureH())
	{
		newh=getMaxTextureH();
	}

	// if newh not power of 2
	while(getbitcount(newh)!=1)
	{
		newh--;
	}
	// if neww not power of 2
	while(getbitcount(neww)!=1)
	{
		neww--;
	}
	// is square ?
	if(newh!=neww)
	{
		int m=MIN(newh,neww);
		newh=m;
		neww=m;
	}
	if(neww!=tga.getW() || newh!=tga.getH())
	{
		outputdebug("CDD::resizing texture:%d %s %d from %dx%d to %dx%d\n",n,name,isbump,tga.getW(),tga.getH(),neww,newh);
		tga.setSize(neww,newh);
	}


	D3DFORMAT textureformat=D3DFMT_A8R8G8B8;
	if(isbump)
	{
		tga.convertUvl16(
			0x0000001F,
			0x0000001F<<5,
			0x0000003F<<10
			);
		textureformat=D3DFMT_L6V5U5;
	}
	else
	{
		if(m_texture32)
		{
			if(tga.getBitDepth()==32)
			{
				tga.convertRgba32(
					0x00FF0000,
					0x0000FF00,
					0x000000FF,
					0xFF000000
					);
				textureformat=D3DFMT_A8R8G8B8;
			}
			else if(tga.getBitDepth()==24)
			{
				tga.convertRgba32(
					0x00FF0000,
					0x0000FF00,
					0x000000FF,
					0x00000000
					);
				textureformat=D3DFMT_A8R8G8B8;
			}
		}
		else
		{
			if(tga.getBitDepth()==32)
			{
				tga.convertRgba16(
					0x0000F00,
					0x00000F0,
					0x000000F,
					0x000F000
					);
				textureformat=D3DFMT_A4R4G4B4;
			}
			else if(tga.getBitDepth()==24)
			{
				tga.convertRgba16(
					0x0000001F<<11,
					0x0000003F<<5,
					0x0000001F,
					0x00000000
					);
				textureformat=D3DFMT_R5G6B5;
			}
		}
	}
	err=m_device->CreateTexture(tga.getW(),tga.getH(),mipmapcount,0,textureformat,D3DPOOL_MANAGED,&m_texture[n].texture);
	if(err!=D3D_OK)
	{
		DDERROR(err);
		goto loaderror;
	}

	levelcount=m_texture[n].texture->GetLevelCount();
	for(level=0;level<levelcount;level++)
	{
		IDirect3DSurface8 *miplevel;
		m_texture[n].texture->GetSurfaceLevel(level,&miplevel);

		if(miplevel)
		{
			D3DLOCKED_RECT lrect;
			err=miplevel->LockRect(&lrect,NULL,0);
			if(err!=D3D_OK)
			{
				DDERROR(err);
				goto loaderror;
			}
			else
			{
				int x,y;
				if(m_texture32)
				{
					unsigned int *ptrsrc=(unsigned int *)tga.getData();
					for (y=0;y<tga.getH();y++)
					{
						unsigned int *ptrdst=(unsigned int *)((unsigned char *)(lrect.pBits)+lrect.Pitch*y);
						for (x=0;x<tga.getW();x++)
						{
							*ptrdst=*ptrsrc;
							ptrdst++;
							ptrsrc++;
						}
					}
				}
				else
				{
					unsigned short *ptrsrc=(unsigned short *)tga.getData();
					for (y=0;y<tga.getH();y++)
					{
						unsigned short *ptrdst=(unsigned short *)((unsigned char *)(lrect.pBits)+lrect.Pitch*y);
						for (x=0;x<tga.getW();x++)
						{
							*ptrdst=*ptrsrc;
							ptrdst++;
							ptrsrc++;
						}
					}
				}

				err=miplevel->UnlockRect();
				if(err!=D3D_OK)
				{
					DDERROR(err);
					goto loaderror;
				}
			}
			tga.divn(2);
		}
		int cnt=miplevel->Release();
	}
	return TRUE;
loaderror:
	// Now we are done with the source texture
    strcat(m_texture[n].filename," *ERROR*");
	if(m_texture[n].texture)
	{
		err=m_texture[n].texture->Release();
		m_texture[n].texture=NULL;
	}
	
	return(FALSE);
}



int Cdd::countLoadableTexture(void)
{
	return DD_TEXTUREMAX;
}



HDC Cdd::createHdc(void)
{
	return(NULL);
}

void Cdd::releaseHdc(HDC hdc)
{
}


void Cdd::show(RECT rcsrc,HWND dstwnd,RECT rcdst)
{
//DX8?
#if 0
	_ASSERT(m_beginrendercount==0);
    HRESULT err;
    RECT rc;
    // blit the memory surface to the video ram back surface
    err=m_clipper->SetHWnd(0,dstwnd);
    if(err!=D3D_OK)
    {
		//TODO
    }
    while(1)
    {
		rc=rcdst;
    	ClientToScreen(dstwnd,(LPPOINT)&rc);
    	ClientToScreen(dstwnd,(LPPOINT)&rc+1);
    	err=m_primary->Blt(&rc,m_backbuffer,&rcsrc,DDBLT_WAIT,NULL);
        if(err==D3D_OK)
        {
            break;
        }
        if(err==DDERR_SURFACELOST)
        {
            err=restoresurfaces();
            if(err!=D3D_OK)
            {
                break;
            }
        }
        if(err!=DDERR_WASSTILLDRAWING )
        {
            break;
        }
    }
    err=m_clipper->SetHWnd(0,m_hwnd);
    if(err!=D3D_OK )
    {
		//TODO
    }
#endif
}

int Cdd::clear(BOOL clearzbuffer,BOOL cleartarget,BOOL clearstencil,float zbuffer,Crgb color,unsigned int stencil)
{
	if(!m_device)
		return 0;
	HRESULT err=D3D_OK;
	int flag=0;
	if(cleartarget)  flag|=D3DCLEAR_TARGET;
	if(clearzbuffer) flag|=D3DCLEAR_ZBUFFER;
	if(clearstencil & m_stencilenable) flag|=D3DCLEAR_STENCIL;

	if(flag)
	{
   		D3DRECT rctoclear;
		rctoclear.x1=float2int(m_fwinx1);
		rctoclear.y1=float2int(m_fwiny1);
		rctoclear.x2=float2int(m_fwinx2);
		rctoclear.y2=float2int(m_fwiny2);
		err=m_device->Clear(1,&rctoclear,flag,color.getrgba(),zbuffer,stencil);
		if(err!=D3D_OK)
		{
			DDERROR(err);
		}
	}
	return err;
}

int Cdd::searchVideoMode(int w,int h,int bpp)
{

	for(int i=0;i<getDeviceCurrentAddr()->m_modecount;i++)
	{
		if(
			getDeviceCurrentAddr()->m_mode[i].getW()==w &&
			getDeviceCurrentAddr()->m_mode[i].getH()==h
			)
			return(i);
	}
	return(0);
}

int Cdd::getBankH(BNKIDX bank)const
{
#if 0
	if(m_texture[GETCACHEIDX1(bank)].texture)
	{
		return m_texture[GETCACHEIDX1(bank)].ddsd.dwHeight;
	}
#endif
	return 256;
}

int Cdd::getBankW(BNKIDX bank)const
{
#if 0	
	if(m_texture[GETCACHEIDX1(bank)].texture)
	{
		return m_texture[GETCACHEIDX1(bank)].ddsd.dwWidth;
	}
#endif
	return 256;
}

int Cdd::getMinTextureW(void)const
{
	return 1;
//DX8?	return m_driver[m_drivercurrent].device.desc.dwMinTextureWidth;
}

int Cdd::getMaxTextureW(void)const
{
	return 1024;
//DX8?	return m_driver[m_drivercurrent].device.desc.dwMaxTextureWidth;
}

int Cdd::getMinTextureH(void)const
{
	return 1;
//DX8?	return m_driver[m_drivercurrent].device.desc.dwMinTextureHeight;
}
int Cdd::getMaxTextureH(void)const
{
//DX8?	return m_driver[m_drivercurrent].device.desc.dwMaxTextureHeight;
	return 1024;
}

int Cdd::getLocalFreeTextureMemory(void)const
{
/*	HRESULT err;
	DDSCAPS2 ddscaps2;
	memset(&ddscaps2,0,sizeof(ddscaps2)); 
	ddscaps2.dwCaps=DDSCAPS_TEXTURE|DDSCAPS_LOCALVIDMEM; 
	unsigned long total,free;
	err=m_dd->GetAvailableVidMem(&ddscaps2,&total,&free);
	if (err!=D3D_OK)
	{
		return -1;
	}
    return free;
*/
	return 1000;
}

int Cdd::getLocalTotalTextureMemory(void)const
{
/*
	HRESULT err;
	DDSCAPS2 ddscaps2;
	memset(&ddscaps2,0,sizeof(ddscaps2)); 
	ddscaps2.dwCaps=DDSCAPS_TEXTURE|DDSCAPS_LOCALVIDMEM; 
	unsigned long total,free;
	err=m_dd->GetAvailableVidMem(&ddscaps2,&total,&free);
	if (err!=D3D_OK)
	{
		return -1;
	}
    return total;
*/
	return 1000;
}

int Cdd::getFreeTextureMemory(void)const
{
/*	HRESULT err;
	DDSCAPS2 ddscaps2;
	memset(&ddscaps2,0,sizeof(ddscaps2)); 
	ddscaps2.dwCaps=DDSCAPS_TEXTURE; 
	unsigned long total,free;
	err=m_dd->GetAvailableVidMem(&ddscaps2,&total,&free);
	if (err!=D3D_OK)
	{
		return -1;
	}
    return free;
	*/
	return 1000;
}

int Cdd::getTotalTextureMemory(void)const
{
/*	HRESULT err;
	DDSCAPS2 ddscaps2;
	memset(&ddscaps2,0,sizeof(ddscaps2)); 
	ddscaps2.dwCaps=DDSCAPS_TEXTURE; 
	unsigned long total,free;
	err=m_dd->GetAvailableVidMem(&ddscaps2,&total,&free);
	if (err!=D3D_OK)
	{
		return -1;
	}
    return total;
*/
	return 1000;
}

void Cdd::setRenderFilter(int value,BOOL forcevalue)
{
//	_ASSERT(m_renderfilter==DD_FILTER_LINEAR || m_renderfilter==DD_FILTER_POINT || m_renderfilter==DD_FILTER_ANISOTROPIC); 
	if(m_renderfilter!=value || forcevalue)
	{
		m_renderfilter=value;
		if(m_beginrendercount!=0)
		{
			flushTriangle();
			dd_SetTextureStageState( 0, D3DTSS_MAGFILTER, m_renderfilter);      
			dd_SetTextureStageState( 0, D3DTSS_MINFILTER, m_renderfilter);      
			if(m_texturestagemax>1)
			{
				dd_SetTextureStageState( 1, D3DTSS_MAGFILTER, m_renderfilter);      
				dd_SetTextureStageState( 1, D3DTSS_MINFILTER, m_renderfilter);      
				if(m_texturestagemax>2)
				{
					dd_SetTextureStageState( 2, D3DTSS_MAGFILTER, m_renderfilter);      
					dd_SetTextureStageState( 2, D3DTSS_MINFILTER, m_renderfilter);      
				}
			}
		}
	}
}

void Cdd::setRenderMipmap(int value,BOOL forcevalue)
{
	_ASSERT(value==DD_MIPMAP_NONE || value==DD_MIPMAP_POINT || value==DD_MIPMAP_LINEAR);
	if(m_rendermipmap!=value || forcevalue)
	{
		m_rendermipmap=value;
		if(m_beginrendercount!=0)
		{
			flushTriangle();
			dd_SetTextureStageState( 0, D3DTSS_MIPFILTER,m_rendermipmap);
			if(m_texturestagemax>1)
			{
				dd_SetTextureStageState( 1, D3DTSS_MIPFILTER,m_rendermipmap);
				if(m_texturestagemax>2)
				{
					dd_SetTextureStageState( 2, D3DTSS_MIPFILTER,m_rendermipmap);
				}
			}
		}
	}
}

void Cdd::setRenderDither(BOOL value,BOOL forcevalue)
{
	if(m_renderdither!=value || forcevalue)
	{
		m_renderdither=value;
		if(m_beginrendercount!=0)
		{
			dd_State(D3DRS_DITHERENABLE,getRenderDither());
		}
	}
}

void Cdd::setRenderZbuffer(BOOL value,BOOL forcevalue)
{
	if(value!=m_renderzbuffer || forcevalue)
	{
		m_renderzbuffer=value;
		if(m_beginrendercount!=0)
		{
			flushTriangle();
			dd_State(D3DRS_ZENABLE,/*m_zbuffer!=NULL && */m_renderzbuffer);
			dd_State(D3DRS_ZWRITEENABLE,/*m_zbuffer!=NULL &&*/ m_renderzbuffer);
			//if(m_zbuffer!=NULL)
				dd_State(D3DRS_ZFUNC,D3DCMP_LESSEQUAL);
		}
	}
}

void Cdd::setRenderAntialias(BOOL value,BOOL forcevalue)
{
	if(m_renderantialias!=value)
	{
		m_renderantialias=value;
		if(m_beginrendercount!=0)
		{
			flushTriangle();
		}
	}
}

void Cdd::setRenderFog(BOOL value,BOOL forcevalue)
{
	if(m_renderfog!=value || forcevalue)
	{
		m_renderfog=value;
		if(m_beginrendercount!=0)
		{
			flushTriangle();
			dd_State(D3DRS_FOGENABLE,m_renderfog);
		}
	}
}

void Cdd::setRenderFogColor(Crgb color,BOOL forcevalue)
{
	if(m_renderfogcolor.rgba!=color.rgba || forcevalue)
	{
		m_renderfogcolor=color;
		if(m_beginrendercount!=0)
		{
			flushTriangle();
			dd_State(D3DRS_FOGCOLOR,getRenderFogColor().getrgba());
		}
	}
}




void Cdd::setNearPlane(float nearplane)
{
	m_nearplane=nearplane;
	m_invnearplane=1.0F/m_nearplane;
	m_nearplane_divmaxz=m_nearplane/getZbufferMax();
	m_invnearplane_divmaxz=getZbufferMax()/m_nearplane;
}



float Cdd::getNearPlane(void)const
{
	return m_nearplane;
}

void Cdd::setBackBufferCount(int count)
{
	if(count<1)
		count=1;
	else
		if(count>2)
			count=2;
	m_backbuffercount=count;
}


void Cdd::setCameraMatrix(Cmat const &mat)
{
	m_matrix=mat;
}


Cmat Cdd::getCameraMatrix(void)
{
	return m_matrix;
}

int Cdd::fontPrepare(int id,char *filename,int w,int h,int bank)
{
	Ctga tga;
	int tgaw=256;
	int tgah=256;
	int ix=0;
	int iy=0;
	int ibank=bank;
	tga.getInfoFromFile(filename,&tgaw,&tgah,NULL);
	for(int i=32;i<256;i++)
	{
		Cuv uv1,uv2;
		uv1.set(((float)(ix)+0.5F)/tgaw,((float)iy+0.5F)/tgah);
		uv2.set(((float)(ix+w)+0.5F)/tgaw,((float)(iy+h)+0.5F)/tgah);
		m_font[id].set(i,uv1,uv2,(float)w,(float)h,ibank);
		ix+=w;
		if(ix+w>tgaw)
		{
			iy+=h;
			ix=0;
			if(iy+h>tgah)
			{
				ibank++;
				iy=0;
			}
		}
	}
	return 1;
}

void Cdd::fontDrawText(int id,SIDEATTR attrib,float x,float y,char *text,float zoom)
{
	Cgfontchar *fontchar;
	Cgvtx gvtx[4];
	unsigned char c;
	attrib|=ATTR_TEXTURED|ATTR_GOURAUD;
	gvtx[0].rgb=m_fontrgb;
	gvtx[1].rgb=m_fontrgb;
	gvtx[2].rgb=m_fontrgb;
	gvtx[3].rgb=m_fontrgb;
	gvtx[0].specular=0;//m_fontspecular;
	gvtx[1].specular=0;//m_fontspecular;
	gvtx[2].specular=0;//m_fontspecular;
	gvtx[3].specular=0;//m_fontspecular;
	c=(unsigned char)(*(text++));
	while(c)
	{
		fontchar=&(m_font[id].m_char[c]);
		BNKIDX bnk=fontchar->getbank();
		Cgvtx a,b;
		gvtx[0].computeclip2dsetz(x,y,getfClipx1(),getfClipy1(),getfClipx2(),getfClipy2());
		gvtx[0].uv.set(fontchar->m_uv1.u,fontchar->m_uv2.v);
		gvtx[1].computeclip2dsetz(x,y-fontchar->geth()*zoom,getfClipx1(),getfClipy1(),getfClipx2(),getfClipy2());
		gvtx[1].uv.set(fontchar->m_uv1.u,fontchar->m_uv1.v);
		x+=fontchar->getw()*zoom;
		gvtx[2].computeclip2dsetz(x,y-fontchar->geth()*zoom,getfClipx1(),getfClipy1(),getfClipx2(),getfClipy2());
		gvtx[2].uv.set(fontchar->m_uv2.u,fontchar->m_uv1.v);
		gvtx[3].computeclip2dsetz(x,y,getfClipx1(),getfClipy1(),getfClipx2(),getfClipy2());
		gvtx[3].uv.set(fontchar->m_uv2.u,fontchar->m_uv2.v);
		quad(attrib,&gvtx[0],&gvtx[1],&gvtx[2],&gvtx[3],bnk);
		c=(unsigned char)(*(text++));
	}
}


void Cdd::fontDrawTextCenter(int id,SIDEATTR attrib,float x,float y,char *text,float zoom)
{
	fontDrawText(id,attrib,x-fontGetTextW(id,text,zoom)*0.5F,y-fontGetTextH(id,zoom)*0.5F,text,zoom);
}

float Cdd::fontGetTextW(int id,char *text,float zoom)
{
	Cgfontchar *fontchar;
	unsigned char c;
	c=(unsigned char)(*(text++));
	float w=0.0F;
	while(c)
	{
		fontchar=&(m_font[id].m_char[c]);
		w+=fontchar->getw()*zoom;
		c=(unsigned char)(*(text++));
	}
	return w;
}

float Cdd::fontGetTextH(int id,float zoom)
{
	Cgfontchar *fontchar;
	fontchar=&(m_font[id].m_char[65]);
	return fontchar->geth()*zoom;
}

float Cdd::fontGetTextFormatedW(int id,char *t,float zoom,float maxw)
{
	float yoffset=0.0F;
	unsigned char *text;
	text=(unsigned char *)t;
	float linelen;
	linelen=0.0F;
	while(*text && linelen<maxw)
	{
			linelen+=m_font[id].m_char[*text].getw();
			text++;
	}
	if(linelen>maxw)
		return maxw;
	return linelen;
}

float Cdd::fontGetTextFormatedH(int id,char *t,float zoom,float maxw)
{
	float yoffset=0.0F;
	unsigned char *text;
	text=(unsigned char *)t;
	while(*text)
	{
		float linelen;
		float addspacew;
		addspacew=0.0F;
		linelen=0.0F;
		while(*text && linelen<maxw)
		{
			// read a word
			float wordlen=0.0F;
			unsigned char *startword=text;
			while(*text && *text==' ')
			{
				text++;
			}
			while(*text && *text!=' ' && wordlen<=maxw)
			{
				wordlen+=m_font[id].m_char[*text].getw();
				text++;
			}
			while(*text && *text==' ')
			{
				text++;
			}
			if(wordlen>maxw)
			{
				text=startword;
				wordlen=0.0F;
				while(*text && *text!=' ' && linelen+addspacew+wordlen<=maxw)
				{
					wordlen+=m_font[id].m_char[*text].getw();
					text++;
				}
				text--;
				wordlen-=m_font[id].m_char[*text].getw();
			}
			if(linelen+wordlen+addspacew<=maxw)
			{
				if(addspacew!=0.0F)
				{
				}
				else
				{
					addspacew=fontGetTextW(id," ",zoom);
				}
				linelen+=wordlen+addspacew;
			}
			else
			{
				text=startword;
				linelen=maxw+1;
			}
		}
		yoffset+=fontGetTextH(id,zoom);
	}
	return yoffset;
}

void Cdd::fontDrawTextFormated(int id,SIDEATTR attrib,float x,float y,char *t,float zoom,float maxw,int align)
{
	float yoffset=0.0F;
	unsigned char *text;
	text=(unsigned char *)t;
	while(*text)
	{
		char line[512];
		float linelen;
		float addspacew;
		addspacew=0.0F;
		linelen=0.0F;
		line[0]=0;
		while(*text && linelen<maxw)
		{
			// read a word
			char word[512];
			float wordlen=0.0F;
			int wordindex=0;
			word[wordindex]=0;
			unsigned char *startword=text;
			while(*text && *text==' ')
			{
				text++;
			}
			while(*text && *text!=' ' && wordlen<=maxw)
			{
				word[wordindex]=*text;
				word[wordindex+1]=0;
				wordindex++;
				wordlen+=m_font[id].m_char[*text].getw();
				text++;
			}
			while(*text && *text==' ')
			{
				text++;
			}
			if(wordlen>maxw)
			{
				text=startword;
				wordindex=0;
				word[wordindex]=0;
				wordlen=0.0F;
				while(*text && *text!=' ' && linelen+addspacew+wordlen<=maxw)
				{
					word[wordindex]=*text;
					word[wordindex+1]=0;
					wordindex++;
					wordlen+=m_font[id].m_char[*text].getw();
					text++;
				}
				text--;
				wordlen-=m_font[id].m_char[*text].getw();
				word[wordindex-1]=0;
			}
			if(linelen+wordlen+addspacew<=maxw)
			{
				if(addspacew!=0.0F)
				{
					strcat(line," ");
				}
				else
				{
					addspacew=fontGetTextW(id," ",zoom);
				}
				strcat(line,word);
				linelen+=wordlen+addspacew;
			}
			else
			{
				text=startword;
				linelen=maxw+1;
			}
		}
		switch(align)
		{
		case -1:
			fontDrawText(id,attrib,x,y+yoffset,line,zoom);
			break;
		case 0:
			fontDrawText(id,attrib,x+(maxw-linelen)/2.0F,y+yoffset,line,zoom);
			break;
		case 1:
			fontDrawText(id,attrib,x+(maxw-linelen),y+yoffset,line,zoom);
			break;
		}
		yoffset+=fontGetTextH(id,zoom);
	}
}
