//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
//	Comment : graphic 3D vtx
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------
#include <stdafx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <g3gvtx.h>

void Cgvtx::set(SIDEATTR const &attrib,Cgvtx const &a,Cgvtx const &b,float ratio)
{
	v2d.x=a.v2d.x+((b.v2d.x-a.v2d.x)*ratio);
	v2d.y=a.v2d.y+((b.v2d.y-a.v2d.y)*ratio);
	iz=a.iz+((b.iz-a.iz)*ratio);
	z=1.0F/iz;
	if(attrib & (ATTR_TEXTURED|ATTR_REFLECTION))
	{
		uv.set(a.uv,b.uv,a.iz,b.iz,z,ratio);
		if(attrib & ATTR_REFLECTION)
		{
			uv2.set(a.uv2,b.uv2,a.iz,b.iz,z,ratio);
		}
	}
	rgb.set(a.rgb,b.rgb,a.iz,b.iz,z,ratio);
	specular.set(a.specular,b.specular,a.iz,b.iz,z,ratio);
//	fog=a.fog+float2int((float)(b.fog-a.fog)*ratio);
}

void Cgvtx::set(SIDEATTR const &attrib,Cgvtx *a,Cgvtx *b,float ratio)
{
	v2d.x=a->v2d.x+((b->v2d.x-a->v2d.x)*ratio);
	v2d.y=a->v2d.y+((b->v2d.y-a->v2d.y)*ratio);
	iz=a->iz+((b->iz-a->iz)*ratio);
	z=1.0F/iz;
	if(attrib & (ATTR_TEXTURED|ATTR_REFLECTION))
	{
		uv.set(a->uv,b->uv,a->iz,b->iz,z,ratio);
		if(attrib & ATTR_REFLECTION)
		{
			uv2.set(a->uv2,b->uv2,a->iz,b->iz,z,ratio);
		}
	}
	rgb.set(a->rgb,b->rgb,a->iz,b->iz,z,ratio);
	specular.set(a->specular,b->specular,a->iz,b->iz,z,ratio);
//	fog=a->fog+float2int((float)(b->fog-a->fog)*ratio);
}



Cgvtx::Cgvtx(SIDEATTR const &attrib,Cgvtx const &a,Cgvtx const &b,float ratio)
{
	set(attrib,a,b,ratio);
}

