//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
//
//	Comment : euler rotations
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------
#include <stdafx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#include <g3mat.h>
#include <g3rot.h>


Crot::Crot(Cv3d const &a,Cv3d const &b)
{
	Cv3d dir=b-a;
	z=0.0F;
    y=0.0F;
	float normxz=(float)sqrt(dir.x*dir.x+dir.z*dir.z);
    if(normxz==0.0F)
	{
		y=0.0F;
	}
	else
	{
		y=(float)atan2(dir.x/normxz,dir.z/normxz);
	}
	x=(float)atan2(-dir.y,normxz);
}


/*
Crot::Crot(Cmat const &mat);
  {
  float sinx,cosx;
  float siny,cosy;
  float sinz,cosz;
  sinx=-m->m32;
  cosx=sqrt(1.0F-(sinx*sinx));
  if(cosx<=0.01)
    {
    x=G3_NBANGLE/4;
    if(sinx<0) x=-G3_NBANGLE/4;
    y=0;
    sinz=-m->m21;
    cosz=-m->m11;
    z=atan2(sinz,cosz);
    }
  else
  {
	  siny=(m->m31)/cosx;
	  cosy=(m->m33)/cosx;
	  sinz=(m->m12)/cosx;
	  cosz=(m->m22)/cosx;
	  x=atan2(sinx,cosx);
	  y=atan2(siny,cosy);
	  z=atan2(sinz,cosz);
  }
  return(G3_TRUE);
  }
*/
int Crot::fread(G3FILE *handle)
{
		int count=0;
		count+=g3fread(&x,sizeof(x),1,handle);
		count+=g3fread(&y,sizeof(y),1,handle);
		count+=g3fread(&z,sizeof(z),1,handle);
		if(count==3)
		{
			centerto0();
			return(1);
		}
	return(0);
}

int Crot::fwrite(G3FILE *handle)
{
		int count=0;
		count+=g3fwrite(&x,sizeof(x),1,handle);
		count+=g3fwrite(&y,sizeof(y),1,handle);
		count+=g3fwrite(&z,sizeof(z),1,handle);
		if(count==3)
			return(1);
	return(0);
}

void Crot::centerto0(void)
{
	while(x>PI) x-=2*PI;
	while(x<-PI) x+=2*PI;
	while(y>PI) y-=2*PI;
	while(y<-PI) y+=2*PI;
	while(z>PI) z-=2*PI;
	while(z<-PI) z+=2*PI;
}

void Crot::rand(Crot const &_rot)
{
	x=floatrand(_rot.x);
	y=floatrand(_rot.y);
	z=floatrand(_rot.z);
}

void Crot::amortize(Crot const &value,float ratio,float time)
{
	float r=ratio*time;
	x=floatamortize(x,value.x,r);
	y=floatamortize(y,value.y,r);
	z=floatamortize(z,value.z,r);
}

void Crot::adjustto(Crot const &wantedvalue,Crot const &step,float time)
{
	x=floatadjustto(x,wantedvalue.x,step.x,time);
	y=floatadjustto(y,wantedvalue.y,step.y,time);
	z=floatadjustto(z,wantedvalue.z,step.z,time);
}

void Crot::setinabsrange(Crot const &max)
{
	x=floatsetinabsrange(x,max.x);
	y=floatsetinabsrange(y,max.y);
	z=floatsetinabsrange(z,max.z);
}

void Crot::setinrange(Crot const &min,Crot const &max)
{
	x=floatsetinrange(x,min.x,max.x);
	y=floatsetinrange(y,min.y,max.y);
	z=floatsetinrange(z,min.z,max.z);
}
