//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------

#include <stdafx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <g3sincos.h>

#define _G3SINCOS_CPP_

Csincos sincos;


Csincos::Csincos()
{
	int i;
	float a;
	for(i=0;i<G3_NBANGLE;i++)
	{
		a=(i*2.0F*PI)/G3_NBANGLE;
		tcos[i]=(float)::cos(a);
		tsin[i]=(float)::sin(a);
	}
}

float Csincos::cos(float angle)const
{
	int a=float2int(angle*(G3_NBANGLE/(2.0F*PI)))&(G3_NBANGLE-1);
 	return(tcos[a]);
}

float Csincos::sin(float angle)const
{
	int a=float2int(angle*(G3_NBANGLE/(2.0F*PI)))&(G3_NBANGLE-1);
	return(tsin[a]);
}

float Csincos::ssin(float angle,float s)const
{
	if(s==0.0F) return sin(angle);
	float a;
	a=fmod(angle,2*PI);
	float oa=a;
	a=floatabs(a);
	float borne=(PI/2)-s*(PI/2);
	if(a<borne)
		a=PI/2*(a/borne);
	else
		a=PI/2+PI/2*(a-borne)/(PI-borne);
	if(oa<0.0F)
	{
		a=-a;
	}
	return(sin(a));
}


void Csincos::sincos(float pangle,float *s,float *c)const
{
	int a=(float2int(pangle*(G3_NBANGLE/(2.0F*PI))))&(G3_NBANGLE-1);
	*s=tsin[a];
	*c=tcos[a];
}
