//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------

#include <stdafx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <mmsystem.h>
#include <g3utils.h>



int __fastcall _ftol(float f)
{
	static int i;
    __asm fistp i;
    return i;
}



void fextput(char const *path,char const *extension,char *rpath)
{
	char drive[ _MAX_DRIVE ];
	char dir[ _MAX_DIR ];
	char fname[ _MAX_FNAME ];
	char ext[ _MAX_EXT ];
	_splitpath(path,drive,dir,fname,ext);
	_makepath(rpath,drive,dir,fname,extension);
}




void fextget(char const *path,char *rpath)
{
	char drive[ _MAX_DRIVE ];
	char dir[ _MAX_DIR ];
	char fname[ _MAX_FNAME ];
	char ext[ _MAX_EXT ];
	_splitpath(path,drive,dir,fname,ext);
	strcpy(rpath,ext);
}

void fnameget(char const *path,char *rpath)
{
	char drive[ _MAX_DRIVE ];
	char dir[ _MAX_DIR ];
	char fname[ _MAX_FNAME ];
	char ext[ _MAX_EXT ];
	_splitpath(path,drive,dir,fname,ext);
	strcpy(rpath,fname);
}



void freadword(FILE *handle,char *ptr)
{
	char c;
	*ptr=0;
	if(!feof(handle))
	{
		c=(char)(fgetc(handle));
		while(!feof(handle) && (c<=' ' || c==':' || c=='\"') )
		{
			c=(char)(fgetc(handle));
		}
		if(!feof(handle))
		{

			while (!feof(handle) && (c>' ' && c!=':' && c!='\"'))
			{
				*(ptr++)=c;
				c=(char)(fgetc(handle));
			}
			*ptr='\000';

		}
	}
}

int ffindword(FILE *handle,char *w)
{
	char word[256];
	freadword(handle,word);
	while(!feof(handle) && strcmp(word,w))
	{
		freadword(handle,word);
	};
	return(!strcmp(word,w));
}

int ffindword2(FILE *handle,char *w1,char *w2)
{
	char word[256];
	freadword(handle,word);
	while(!feof(handle) && (strcmp(word,w1) && strcmp(word,w2)))
	{
		freadword(handle,word);
	};
	if(strcmp(word,w1)==0) return 1;
	if(strcmp(word,w1)==0) return 2;
	return 0;
}



UD getbitcount(UD mask)
{
	UD i,count;
	i=0;
	count=0;
	while( (i<32) && ((mask & (1<<i)) == 0) ) i++;
	while( (i<32) && ((mask & (1<<i)) != 0) ) 
	{
		i++;
		count++;
	}
	return(count);
}

UD getlbitshift(UD mask)
{
	int i;
	i=0;
	while( (i<32) && ((mask & (1<<(31-i))) == 0) ) i++;
	return(i);
}



UD getrbitshift(UD mask)
{
	int i;
	i=0;
	while( (i<32) && ((mask & (1<<i)) == 0) ) i++;
	return(i);
}

void memswap(unsigned char *p1,unsigned char *p2,unsigned int _size)
{
		__asm
		{
			mov	ecx,[_size]
			mov	esi,[p1]
			mov	edi,[p2]
			mov	edx,ecx
			shr	ecx,3
			je	short _little
_loop:		mov	eax,[esi]
			mov	ebx,[esi+4]
			xchg	eax,[edi]
			xchg	ebx,[edi+4]
			mov	[esi],eax
			mov	[esi+4],ebx
			add	esi,8
			add	edi,8
			dec	ecx
			jne	short _loop
_little:	mov	ecx,edx
			and	ecx,7
			je	short _over
_loop2:		mov	al,[esi]
			xchg	al,[edi]
			mov	[esi],al
			inc	esi
			inc	edi
			dec	ecx
			jne	short _loop2
_over:
		}
}

BOOL clipinwindow(
				  float *x1,float *y1,float *x2,float *y2,
				  float fwinx1,float fwiny1,float fwinx2,float fwiny2
				  )
{
		
		// clipping en Y
		if (*y1>*y2)
		{
			float tmp;
			tmp=*x1;*x1=*x2;*x2=tmp;
			tmp=*y1;*y1=*y2;*y2=tmp;
		}
		if(*y2<fwiny1) return FALSE;
		if(*y1>fwiny2) return FALSE;
		if(*y1<fwiny1)
		{
			float dy=*y2-*y1;
			if(dy==0.0F) return FALSE;
			*x1-=((*x2-*x1)*(*y1-fwiny1))/dy;
			*y1=fwiny1;
		}
		if(*y2>fwiny2)
		{
			float dy=*y2-*y1;
			if(dy==0.0F) return FALSE;
			*x2-=((*x2-*x1)*(*y2-fwiny2))/dy;
			*y2=fwiny2;
		}
		// clipping en X
		if (*x1>*x2)
		{
			float tmp;
			tmp=*x1;*x1=*x2;*x2=tmp;
			tmp=*y1;*y1=*y2;*y2=tmp;
		}
		if (*x2<fwinx1) return FALSE;
		if (*x1>fwinx2) return FALSE;
		if(*x1<fwinx1)
		{
			float dx=*x2-*x1;
			if(dx<=0.0F) return FALSE;
			*y1-=((*y2-*y1)*(*x1-fwinx1))/dx;
			*x1=fwinx1;
		}
		if(*x2>fwinx2)
		{
			float dx=*x2-*x1;
			if(dx<=0.0F) return FALSE;
			*y2-=((*y2-*y1)*(*x2-fwinx2))/dx;
			*x2=fwinx2;
		}

		return(TRUE);
}


int	isrdtscsupported(void)
{
	int		res=0;
	__asm
	{
		push	eax
		push	ebx
		push	ecx
		push	edx
		pushfd
		// If ID bit of EFLAGS can be modified, CPUID instruction is supported
		pushfd
		pop		eax					// Read EFLAG
		mov		ecx,eax
		xor		eax,0x200000		// Flip ID bit
		push	eax
		popfd
		pushfd
		pop		eax					// Reread EFLAG

		xor		eax,ecx
		je		end_test
		// CPUID instruction is supported
		xor		eax,eax	
		_emit	0x0F				// CPUID instruction with eax=0
		_emit	0xa2
		cmp		eax,1
		jl		end_test
		xor		eax,eax
		inc		eax
		_emit	0x0F				// CPUID instruction with eax=1
		_emit	0xa2
		// If bit 4 of EDX set to 1, the uproc support RDTSC instruction
		test	edx,0x010
		je		end_test
		mov		[res],1				// RDTSC instruction is supported by uproc
	end_test:
		popfd
		pop		edx
		pop		ecx
		pop		ebx
		pop		eax
	}
	return res;
}

int ismmxsupported(void)
{
	BOOL	_bmmx = FALSE;
	__asm
	{
		pushad
		pushfd			// Store original
	// If ID bit of EFLAGS can be modified, CPUID instruction is supported
		pushfd
		pop		eax					// Read EFLAG
		mov		ecx,eax
		xor		eax,0x200000		// Flip ID bit
		push	eax
		popfd						// Write new EFLAGS
		pushfd						// 
		pop		eax					// Reread EFLAG
		xor		eax,ecx				// Check if the bit has flip
		je		short noCpuid		// No flip ? CPUID instruction not supported.
	// CPUID instruction is supported
		xor		eax,eax	
		_emit	0x0F				// CPUID instruction with eax=0
		_emit	0xa2
		cmp		eax,1
		jl		short noMmx
	// Ici la fonction 1 de CPUID est supporte.
		mov		eax,1
		_emit	0x0F				// CPUID instruction with eax=1
		_emit	0xa2
		test	edx,0x800000		// Check bit 23: MMX Technology
		je		short	noMmx
		mov		[_bmmx],TRUE
noMmx:
noCpuid:
		popfd						// restore original.
		popad
	}
	return _bmmx;
}

__int64 getrdtsc(void)
{
	__int64 res=0;
	if (isrdtscsupported())
	{		
		__asm
		{
			push	eax
			push	edx
			_emit	0x0F			// RDTSC Pentium instruction
			_emit	0x31			// return nb of cycle in EDX:EAX
			mov		DWORD PTR[res+4],edx
			mov		DWORD PTR[res],eax
			pop		edx
			pop		eax
		}
	}
	return res;
}


int cputype(void)
{
	int ret=CPUTYPE_KATMAI;
	//Checking for Katmai New Instruction
	__try
	{
			__asm _emit 0x0F 
			__asm _emit 0x28 
			__asm _emit 0xC0
	}
	//If there's an exception, then set the emulation variable to False.
	__except(EXCEPTION_EXECUTE_HANDLER){ret=CPUTYPE_NORMAL;}
	return ret;
}


void rgbtohsv( float r, float g, float b, float *h, float *s, float *v )
{
	float min, max, delta;
	min = MIN3( r, g, b );
	max = MAX3( r, g, b );
	*v = max;				// v
	delta = max - min;
	if( max != 0 )
		*s = delta / max;		// s
	else {
		// r = g = b = 0		// s = 0, v is undefined
		*s = 0;
		*h = -1;
		return;
	}
	if( r == max )
		*h = ( g - b ) / delta;		// between yellow & magenta
	else if( g == max )
		*h = 2 + ( b - r ) / delta;	// between cyan & yellow
	else
		*h = 4 + ( r - g ) / delta;	// between magenta & cyan
	*h *= 60;				// degrees
	if( *h < 0 )
		*h += 360;
}

void hsvtorgb(float h, float s, float v,float *r, float *g, float *b)
{
	int i;
	float f, p, q, t;
	if( s == 0 ) {
		// achromatic (grey)
		*r = *g = *b = v;
		return;
	}
	h /= 60;			// sector 0 to 5
	i = floor( h );
	f = h - i;			// factorial part of h
	p = v * ( 1 - s );
	q = v * ( 1 - s * f );
	t = v * ( 1 - s * ( 1 - f ) );
	switch( i ) {
		case 0:
			*r = v;
			*g = t;
			*b = p;
			break;
		case 1:
			*r = q;
			*g = v;
			*b = p;
			break;
		case 2:
			*r = p;
			*g = v;
			*b = t;
			break;
		case 3:
			*r = p;
			*g = q;
			*b = v;
			break;
		case 4:
			*r = t;
			*g = p;
			*b = v;
			break;
		default:		// case 5:
			*r = v;
			*g = p;
			*b = q;
			break;
	}
}
