//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------

#include <stdafx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <g3uv.h>
#include <g3utils.h>

int Cuv::fread(G3FILE *handle)
{

	

	UW version;
	g3fread(&version,sizeof(version),1,handle);
	switch(version)
	{
	case 1:
		{
		int count=0;
		count+=g3fread(&u,sizeof(u),1,handle);
		count+=g3fread(&v,sizeof(v),1,handle);
		if(count==2)
			return(1);
		}
		break;
	default:
		::MessageBox(NULL,"UV : UNKNOWN VERSION","ERROR",MB_ICONWARNING|MB_OK);
		exit(0);
		break;

	}
	return(0);
}



int Cuv::fwrite(G3FILE *handle)
{
	UW version=1;
	g3fwrite(&version,sizeof(version),1,handle);
	int count=0;
	count+=g3fwrite(&u,sizeof(u),1,handle);
	count+=g3fwrite(&v,sizeof(v),1,handle);
	if(count==2)
		return(1);
	return(0);
}


Cuv getpos(
		   float x,float y,
		   float x1,float y1,float iz1,Cuv uv1,
		   float x2,float y2,float iz2,Cuv uv2,
		   float x3,float y3,float iz3,Cuv uv3
		   )
{
	float lu,lv;
	float ru,rv;
	float lx,rx;
	float liz,riz;
	float u,v,iz;

	uv1.u*=iz1;
	uv1.v*=iz1;
	uv2.u*=iz2;
	uv2.v*=iz2;
	uv3.u*=iz3;
	uv3.v*=iz3;

	// the first point is the highest
	while(y1>y2 || y1>y3)
	{
		{
			float tmp;
			tmp=x1;x1=x2;x2=x3;x3=tmp;
			tmp=y1;y1=y2;y2=y3;y3=tmp;
			tmp=iz1;iz1=iz2;iz2=iz3;iz3=tmp;
			tmp=uv1.u;uv1.u=uv2.u;uv2.u=uv3.u;uv3.u=tmp;
			tmp=uv1.v;uv1.v=uv2.v;uv2.v=uv3.v;uv3.v=tmp;
		}
	}
	if(y2<y3)
	{
	//
		/*-------------------------------------------------
		 Y2 between Y1 and Y3	

					  1
					  +
					 / \
					/   \		part1
				   /     \
				  /....---+2
				 /  ---		
			   3+---
		--------------------------------------------------*/
		lx		=x1+((x3-x1)*(y-y1))/(y3-y1);
		liz		=iz1+((iz3-iz1)*(y-y1))/(y3-y1);
		lu		=uv1.u+((uv3.u-uv1.u)*(y-y1))/(y3-y1);
		lv		=uv1.v+((uv3.v-uv1.v)*(y-y1))/(y3-y1);
		if(y<=y2)
		{
			rx		=x1+((x2-x1)*(y-y1))/(y2-y1);
			riz		=iz1+((iz2-iz1)*(y-y1))/(y2-y1);
			ru		=uv1.u+((uv2.u-uv1.u)*(y-y1))/(y2-y1);
			rv		=uv1.v+((uv2.v-uv1.v)*(y-y1))/(y2-y1);
		}
		else
		{
			rx		=x2+((x3-x2)*(y-y2))/(y3-y2);
			riz		=iz2+((iz3-iz2)*(y-y2))/(y3-y2);
			ru		=uv2.u+((uv3.u-uv2.u)*(y-y2))/(y3-y2);
			rv		=uv2.v+((uv3.v-uv2.v)*(y-y2))/(y3-y2);
		}
	}
	else
	{
		/*-------------------------------------------------
		 case 2 : Y3 between Y1 and Y2

					  1
				   ---+
				---  /  
		   3+---..../    		part1
			 \     /      
			  \   /           
			   \+/           
				2
		--------------------------------------------------*/
		rx		=x1+((x2-x1)*(y-y1))/(y2-y1);
		riz		=iz1+((iz2-iz1)*(y-y1))/(y2-y1);
		ru		=uv1.u+((uv2.u-uv1.u)*(y-y1))/(y2-y1);
		rv		=uv1.v+((uv2.v-uv1.v)*(y-y1))/(y2-y1);
		if(y<=y3)
		{
			lx		=x1+((x3-x1)*(y-y1))/(y3-y1);
			liz		=iz1+((iz3-iz1)*(y-y1))/(y3-y1);
			lu		=uv1.u+((uv3.u-uv1.u)*(y-y1))/(y3-y1);
			lv		=uv1.v+((uv3.v-uv1.v)*(y-y1))/(y3-y1);
		}
		else
		{
			lx		=x3+((x2-x3)*(y-y3))/(y2-y3);
			liz		=iz3+((iz2-iz3)*(y-y3))/(y2-y3);
			lu		=uv3.u+((uv2.u-uv3.u)*(y-y3))/(y2-y3);
			lv		=uv3.v+((uv2.v-uv3.v)*(y-y3))/(y2-y3);
		}
	}
	//
	u	= lu+((ru-lu)*(x-lx))/(rx-lx);
	v	= lv+((rv-lv)*(x-lx))/(rx-lx);
	iz	= liz+((riz-liz)*(x-lx))/(rx-lx);
	return Cuv(u/iz,v/iz);
}

BOOL Cuv::isintriangle(Cuv const &a,Cuv const &b,Cuv const &c)const
{
	return(
	 ((b-a)^((*this)-b))>=0	&&
	 ((c-b)^((*this)-c))>=0	&&
	 ((a-c)^((*this)-a))>=0
	);
}

BOOL Cuv::iswraporequal(Cuv const &a,float tolerance)const
{
	if(
		floatabs((u-(float)float2int(u))-(a.u-(float)float2int(a.u)))>tolerance
		)
		return FALSE;
	if(
		floatabs((v-(float)float2int(v))-(a.v-(float)float2int(a.v)))>tolerance
		)
		return FALSE;
	return TRUE;
}
