//-----------------------------------------------------------------------------
// (C) 1997	Levastre Claude
//
// Last modified		:
// To do				:
//-----------------------------------------------------------------------------
#include <stdafx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <g3v2d.h>
#include <g3utils.h>
#include <g3splinef.h>

Cv2d spline(Cv2d const &v1,Cv2d const &v2,Cv2d const &v3,Cv2d const &v4,CsplineFactor const &sf)
{
	Cv2d res;
	res.x=v1.x*sf.getm1()+v2.x*sf.getm2()+v3.x*sf.getm3()+v4.x*sf.getm4();
	res.y=v1.y*sf.getm1()+v2.y*sf.getm2()+v3.y*sf.getm3()+v4.y*sf.getm4();
	return(res);
}

Cv2d spline(Cv2d const &v1,Cv2d const &v2,Cv2d const &v3,Cv2d const &v4,float t)
{
	Cv2d res;
	res=spline(v1,v2,v3,v4,CsplineFactor(t));
	return(res);
}

int Cv2d::fread(G3FILE *handle)
{
	UW version;
	g3fread(&version,sizeof(version),1,handle);
	switch(version)
	{
	case 1:
		{
		int count=0;
		count+=g3fread(&x,sizeof(x),1,handle);
		count+=g3fread(&y,sizeof(y),1,handle);
		if(count==2)
			return(1);
		}
		break;
	default:
		::MessageBox(NULL,"V2D : UNKNOWN VERSION","ERROR",MB_ICONWARNING|MB_OK);
		exit(0);
		break;

	}
	return(0);
}

int Cv2d::fwrite(G3FILE *handle)
{
	UW version=1;
	g3fwrite(&version,sizeof(version),1,handle);
	int count=0;
	count+=g3fwrite(&x,sizeof(x),1,handle);
	count+=g3fwrite(&y,sizeof(y),1,handle);
	if(count==2)
		return(1);
	return(0);
}

BOOL Cv2d::isintriangle(Cv2d const &a,Cv2d const &b,Cv2d const &c)const
{
	return(
	 ((b-a)^((*this)-b))>=0	&&
	 ((c-b)^((*this)-c))>=0	&&
	 ((a-c)^((*this)-a))>=0
	);
}
